unit Banco;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, Grids, DBGrids, StdCtrls, Buttons, ExtCtrls, ComCtrls;

type
  TfrmBanco = class(TForm)
    tblBanco: TTable;
    dtsBanco: TDataSource;
    tblAgencia: TTable;
    dtsAgencia: TDataSource;
    pcBanco: TPageControl;
    tabBanco: TTabSheet;
    tabConta: TTabSheet;
    Panel1: TPanel;
    dbgBanco: TDBGrid;
    btnIncBanco: TBitBtn;
    btnExcBanco: TBitBtn;
    btnSair: TBitBtn;
    Panel2: TPanel;
    dbgAgencia: TDBGrid;
    btnIncAg: TBitBtn;
    btnExcAg: TBitBtn;
    btnEditAg: TBitBtn;
    Panel3: TPanel;
    dbgConta: TDBGrid;
    tblConta: TTable;
    dtsConta: TDataSource;
    btnIncConta: TBitBtn;
    btnExcConta: TBitBtn;
    tblBancoBanco: TStringField;
    tblBancoNome: TStringField;
    tblAgenciaAgencia: TStringField;
    tblAgenciaBanco: TStringField;
    tblAgenciaNome: TStringField;
    tblAgenciaEndereco: TStringField;
    tblAgenciaGerente: TStringField;
    tblAgenciaTelefone: TStringField;
    tblAgenciaRamal: TStringField;
    tblAgenciaFax: TStringField;
    tblAgenciaInternet: TStringField;
    tblAgenciaDataHora: TDateTimeField;
    tblContaContaCorrente: TStringField;
    tblContaBanco: TStringField;
    tblContaAgencia: TStringField;
    tblContaLimite: TCurrencyField;
    tblContaTipo: TFloatField;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure dbgBancoEnter(Sender: TObject);
    procedure dbgBancoCellClick(Column: TColumn);
    procedure btnIncBancoClick(Sender: TObject);
    procedure btnExcBancoClick(Sender: TObject);
    procedure btnIncAgClick(Sender: TObject);
    procedure btnSairClick(Sender: TObject);
    procedure btnEditAgClick(Sender: TObject);
    procedure btnExcAgClick(Sender: TObject);
    procedure btnIncContaClick(Sender: TObject);
    procedure dbgAgenciaEnter(Sender: TObject);
    procedure dbgAgenciaCellClick(Column: TColumn);
    procedure btnExcContaClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmBanco: TfrmBanco;

implementation

uses IncBanco, Agencia, ContaCorrente, MenuPri;

{$R *.DFM}

{Esta procedure ser executada quando ocorrer o evento Create do formulrio frmBanco}
procedure TfrmBanco.FormCreate(Sender: TObject);
begin
   {As trs prximas linhas abrem as tabelas banco, agncia e Conta Corrente}
   Self.tblBanco.Open;
   Self.tblAgencia.Open;
   Self.tblConta.Open;
   {Executa o evento Enter do objeto dbgBanco}
   frmBanco.dbgBancoEnter(frmBanco);
   {Executa o evento Enter do objeto dbgAgencia}
   frmBanco.dbgAgenciaEnter(frmBanco);
end;

{Esta procedure ser executada quando ocorrer o evento Close do formulrio frmBanco}
procedure TfrmBanco.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   {As trs prximas linhas fecahm as respectivas tabelas}
   Self.tblBanco.Close;
   Self.tblAgencia.Close;
   Self.tblConta.Close;
   {Habilita a opo Banco do menu Cadastro}
   frmMenuPri.Banco1.Enabled := True;
   {The form is closed and all allocated memory for the form is freed}
   Action := CAFree;
end;

{Esta procedure ser executada quando ocorrer o evento Enter do objeto Grid dbgBanco}
procedure TfrmBanco.dbgBancoEnter(Sender: TObject);
begin
   {Insere um string na propriedade filter do objeto tblAgencia.
   (filtra todas as agncias do respectivo Banco)}
   tblAgencia.Filter := 'Banco = ' + (frmBanco.dbgBanco.Columns.Items[0].Field.Text);
   {Confirma o filtro, ou seja torna a propriedade Filtered como verdadeira}
   tblAgencia.Filtered := True;
   {Insere na barra de ttulo do form o nome do banco selecionado}
   Self.Caption := (frmBanco.dbgBanco.Columns.Items[1].Field.Text);
end;

{Esta procedure ser executada quando ocorrer o evento CellClick do objeto Grid dbgBanco}
procedure TfrmBanco.dbgBancoCellClick(Column: TColumn);
begin
   {Executa o evento Enter do objeto Grid dbgBanco}
   frmBanco.dbgBancoEnter(frmBanco);
end;

{Esta procedure ser executada quando ocorrer o evento Click do boto btnIncBanco}
procedure TfrmBanco.btnIncBancoClick(Sender: TObject);
begin
   {Cria o formulrio frmIncBanco, para a incluso de um novo Banco}
   Application.CreateForm(TfrmIncBanco, frmIncBanco);
   {Coloca o objeto tblBanco no modo de incluso}
   Self.tblBanco.Append;
end;

{Esta procedure ser executada quando ocorrer o evento Click do boto btnExcBanco}
procedure TfrmBanco.btnExcBancoClick(Sender: TObject);
begin
   {Ser mostrada uma mensagem para a confirmao da excluso}
	If Application.MessageBox('Confirma a Excluso deste Banco?', 'Confirmao', mb_YesNo + mb_IconQuestion) = idYes then
      {Aqui ser feito um teste, se ocorrer um erro do tipo EDBEngineError, um erro
      que ocorre quando existe uma integridade referencial, ou seja, no se pode
      excluir um banco que tenha(m) agncia(s) cadastrada(s), ento ser mostrada uma
      mensagem que avisa o usurio da impossibilidade da excluso}
   	try
			Self.tblBanco.Delete;
      except
      on EDBEngineError do
      Application.MessageBox ('Existe agncia(s) cadastrada(s) para este Banco' +
      Chr(13) + 'No  possvel excluir este Banco.', 'Erro', mb_Ok + mb_IconError);
      end;
   {Executa o evento Enter do objeto grid dbgBanco}
   frmBanco.dbgBancoEnter(frmBanco);
end;

{Esta procedure ser executada quando ocorrer o evento Click do boto btnIncAg}
procedure TfrmBanco.btnIncAgClick(Sender: TObject);
begin
   {Cria o formulrio frmAgencia}
   Application.CreateForm(TfrmAgencia, frmAgencia);
   {Coloca o objeto tblAgencia em modo de incluso}
   Self.tblAgencia.Append;
   {Preenche o objeto EditBanco com o nmero do banco onde ser cadastrada uma nova agncia}
   frmAgencia.EditBanco.Text := frmBanco.dbgBanco.Columns.Items[0].Field.Text;
   {Insere na barra de ttulo do formulrio o nome do banco onde ser incluida a agncia}
   frmAgencia.Caption := 'Incluir Agncia do ' + frmBanco.dbgBanco.Columns.Items[1].Field.Text;
end;

{Esta procedure ser executada quando ocorrer o evento Click do boto btnSair}
procedure TfrmBanco.btnSairClick(Sender: TObject);
begin
   {Fecha o formulrio}
   Self.Close;
end;

{Esta procedure ser executada quando ocorrer o evento Click do boto btnEditAg}
procedure TfrmBanco.btnEditAgClick(Sender: TObject);
begin
	{Condio para verificar se existe(m) Agncia(s) cadastradas}
	if tblAgencia.RecordCount <> 0 then
   	begin
   		{Cria o formulrio frmAgencia}
   		Application.CreateForm(TfrmAgencia, frmAgencia);
   		{Coloca o objeto tblAgencia em modo de edio}
   		Self.tblAgencia.Edit;
   		{Insere na barra de ttulo do formulrio o nome do banco em que a agncia est sendo
   		alterada}
   		frmAgencia.Caption := 'Editar Agncia do ' + frmBanco.dbgBanco.Columns.Items[1].Field.Text;
   		{Insere no objeto mskTelefone o contedo do objeto EditTelefone}
   		frmAgencia.mskTelefone.Text := frmAgencia.EditTelefone.Text;
   		{Insere no objeto mskFax o contedo do objeto EditFax}
   		frmAgencia.mskFax.Text := frmAgencia.EditFax.Text;
      end
   else
   	{Caso no haja nenhuma agncia cadastrada, ento exibe uma mensagem}
   	Application.MessageBox('No existe nenhuma agncia para ser editada', 'Erro',
      mb_Ok + mb_IconError);
end;

{Esta procedure ser executada quando ocorrer o evento Click do boto btnExcAg}
procedure TfrmBanco.btnExcAgClick(Sender: TObject);
begin
	{Condio para verificar se existe(m) Agncia(s) cadastradas}
	if tblAgencia.RecordCount <> 0 then
   	begin
			{Ser mostrado uma mensagem para confirmar a excluso da agncia}
			if Application.MessageBox('Confirma a Excluso desta Agncia ?', 'Confirmao',
         mb_YesNo + mb_IconQuestion) = idYes then
      		{Aqui ser feito um teste, se ocorrer um erro do tipo EDBEngineError, um erro
      		que ocorre quando existe uma integridade referencial, ou seja, no se pode
      		excluir uma agncia que tenha(m) Conta(s) Correntes(s) cadastrada(s),
      		ento ser mostrada uma mensagem que avisa o usurio da impossibilidade da excluso}
   			try
					frmBanco.tblAgencia.Delete;
      		except
      		on EDBEngineError do
      		Application.MessageBox('Existe(m) Conta(s) Corrente(s) cadastrada(s) para esta Agncia' +
            Chr(13) + 'No  possvel excluir esta Agncia.', 'Erro', mb_Ok + Mb_IconError);
      		end;
      end
   else
   	{Caso no haja nenhuma agncia cadastrada, ento exibe uma mensagem}
   	Application.MessageBox('No existe nenhuma agncia para ser excluda',
       'Erro', mb_Ok + mb_IconError);
end;

{Esta procedure ser executada quando ocorrer o evento Click do boto btnIncConta}
procedure TfrmBanco.btnIncContaClick(Sender: TObject);
begin
	{Condio para verificar se existe agncia cadastrada}
	if tblAgencia.RecordCount <> 0 then
   	begin
   		{Cria o formulrio frmContaCorrente}
   		Application.CreateForm(TfrmContaCorrente, frmContaCorrente);
   		{Coloca o objeto tblConta em modo de incluso}
   		Self.tblConta.Append;
   		{Insere no objeto EditBanco o nmero do banco onde a nova conta ser incluida}
   		frmContaCorrente.EditBanco.Text := frmBanco.dbgBanco.Columns.Items[0].Field.Text;
   		{Insere no objeto EditAgencia o nmero da agncia onde a nova conta ser incluida}
   		frmContaCorrente.EditAgencia.Text := frmBanco.dbgAgencia.Columns.Items[0].Field.Text;
   		{insere na barra de ttulo o nome do banco e a agncia onde a conta ser incluida}
   		frmContaCorrente.Caption := frmBanco.dbgBanco.Columns.Items[1].Field.Text +
   		' - ' + frmBanco.dbgAgencia.Columns.Items[1].Field.Text;
      end
   else
   	{Se a condio for falsa, ento mostra uma mensagem informando a impossiblidade
      do cadastro de uma conta corrente}
   	Application.MessageBox('No existe nenhuma Agncia cadastrada', 'Informao',
       mb_Ok + mb_IconInformation)
end;

{Esta procedure ser executada quando ocorrer o evento Enter no objeto Grid dbgAgencia}
procedure TfrmBanco.dbgAgenciaEnter(Sender: TObject);
begin
	{Condio para verificar se existe uma conta corrente para a agncia selecionada}
	if tblAgencia.RecordCount <> 0 then
   	begin
   		{Insere um string na propriedade filter do objeto tblConta.
   		(filtra todas as contas da respectiva Agncia)}
   		tblConta.Filter := 'Agencia = ' + (frmBanco.dbgAgencia.Columns.Items[0].Field.Text);
   		{Confirma o filtro, ou seja torna a propriedade Filtered como verdadeira}
   		tblConta.Filtered := True;
   	end
   else
   	begin
   		{Se a condio for falsa, ento o dbgConta fica vazio}
   		tblConta.Filter := 'Agencia = 0';
      	{Confirma o filtro, ou seja torna a propriedade Filtered como verdadeira}
      	tblConta.Filtered := True;
      end;
end;

{Esta procedure ser executada quando ocorrer o evento CellClick do objeto Grid dbgAgencia}
procedure TfrmBanco.dbgAgenciaCellClick(Column: TColumn);
begin
   {Executa o evento Enter do objeto Grid dbgAgencia}
   frmBanco.dbgAgenciaEnter(frmBanco);
end;

{Esta procedure ser executada quando ocorrer o evento Click do boto btnExcConta}
procedure TfrmBanco.btnExcContaClick(Sender: TObject);
begin
	{Verifica se exite(m) conta(s) cadastradas}
	if tblConta.RecordCount <> 0 then
   	begin
   		{Ser mostrada uma mensagem confirmando a excluso}
			if Application.MessageBox('Confirma a Excluso desta Conta Corrente?',
            'Confirmao', mb_YesNo + mb_IconQuestion) = idYes then
      		try
         		{Aqui ser feito um teste, se ocorrer um erro do tipo EDBEngineError, um erro
         		que ocorre quando existe uma integridade referencial, ou seja, no se pode
         		excluir uma Conta Corrente que tenha(m) Cheque(s) Pr-Datado(s) cadastrado(s),
         		ento ser mostrada uma mensagem que avisa o usurio da impossibilidade da excluso}
					frmBanco.tblConta.Delete;
      		except
         		on EDBEngineError do
         			Application.MessageBox('Existe(m) Cheques(s) Pr-Datado(s) cadastrado(s) para esta Conta Corrente' +
      				Chr(13) + 'No  possvel excluir esta Conta Corrente.', 'Erro', mb_Ok + mb_IconError);
      		end;
      end
   else
   		{Se a condio for falsa, ento mostra uma mensagem informando a impossiblidade
      	da excluso}
   		Application.MessageBox('No existe nenhuma Conta Corrente cadastrada', 'Informao', mb_Ok + mb_IconInformation)
end;

end.
