unit Cartorio;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, Grids, DBGrids, StdCtrls, Buttons, Mask, DBCtrls;

type
  TfrmCartorio = class(TForm)
    dbgCartorio: TDBGrid;
    tblCartorio: TTable;
    dtsCartorio: TDataSource;
    btnIncluir: TBitBtn;
    btnEditar: TBitBtn;
    btnDeletar: TBitBtn;
    btnSair: TBitBtn;
    EditRegistro: TDBEdit;
    EditCartorio: TDBEdit;
    EditContato: TDBEdit;
    EditTelefone: TDBEdit;
    lblCartorio: TLabel;
    lblContato: TLabel;
    lblTelefone: TLabel;
    mskTelefone: TMaskEdit;
    btnOk: TBitBtn;
    btnCancelar: TBitBtn;
    tblCartorioRegistro: TAutoIncField;
    tblCartorioNome: TStringField;
    tblCartorioContato: TStringField;
    tblCartorioTelefone: TStringField;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure AbreForm(Sender: TObject);
    procedure FechaForm(Sender: TObject);
    procedure mskTelefoneChange(Sender: TObject);
    procedure btnIncluirClick(Sender: TObject);
    procedure btnCancelarClick(Sender: TObject);
    procedure btnSairClick(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
    procedure btnEditarClick(Sender: TObject);
    procedure btnDeletarClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmCartorio: TfrmCartorio;

implementation

uses MenuPri;

{$R *.DFM}

{Esta procedure ser executada quando ocorrer o evento Create no formulrio frmCartorio}
procedure TfrmCartorio.FormCreate(Sender: TObject);
begin
   {abrir a tabela do objeto tblCartorio}
   Self.tblCartorio.Open;
end;

{Esta procedure ser executada quando ocorrer o evento Close no formulrio frmCartorio}
procedure TfrmCartorio.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
   {fecha a tabela do objeto tblCartorio}
   Self.tblCartorio.Close;
   {Habilita a opo Cartrio do menu Cadastro}
   frmMenuPri.Cartorio1.Enabled := True;
   {O formulrio  fechado e toda a memria alocada  liberada}
   Action := CaFree;
end;

{Esta procedure ser executada quando ocorrer o evento Change no objeto mskTelefone}
procedure TfrmCartorio.mskTelefoneChange(Sender: TObject);
begin
   {Comando para copiar o contedo do objeto mskTelefone.Text para o objeto
   DBEdit EditTelefone.Text}
   Self.EditTelefone.Text := Self.mskTelefone.Text;
end;

{Esta procedure ser executada quando ocorrer o evento Click no boto btnIncluir}
procedure TfrmCartorio.btnIncluirClick(Sender: TObject);
begin
   {Inclui um texto na barra de ttulo do formulrio}
   Self.Caption := 'Incluso de Cartrio';
   {Executa a procedure AbreForm}
   Self.AbreForm(frmCartorio);
   {Coloca a tabela do objeto tblCartorio no modo de incluso}
   Self.tblCartorio.Append;
   {Deixa o contedo do objeto mskTelefone em branco}
   Self.mskTelefone.Text := '';
   {Coloca o foco no objeto EdtitCartorio}
   Self.EditCartorio.SetFocus;
end;

{Esta procedure ser executada quando for acionada a partir de um comando da fonte}
procedure TfrmCartorio.AbreForm(Sender: TObject);
begin
   {Todas as linhas abaixo entre begin e end se referem ao formulrio frmCartorio}
   with frmCartorio do
      begin
         {Altura do formulrio ser alterada para 265}
         Height := 265;
         {As 8 linhas abaixo so comandos que os respectivos objetos passam a ser visveis}
         lblCartorio.Visible := True;
         lblContato.Visible := True;
         lblTelefone.Visible := True;
         EditCartorio.Visible := True;
         EditContato.Visible := True;
         mskTelefone.Visible := True;
         btnOk.Visible := True;
         btnCancelar.Visible := True;
         {As 5 linhas abaixo so comandos que desabilitam os respectivos objetos}
         dbgCartorio.Enabled := False;
         btnIncluir.Enabled := False;
         btnEditar.Enabled := False;
         btnDeletar.Enabled := False;
         btnSair.Enabled := False;
      end;
end;

{Esta procedure ser executada quando for acionada a partir de um comando da fonte}
procedure TfrmCartorio.FechaForm(Sender: TObject);
begin
   {Todas as linhas abaixo entre begin e end se referem ao formulrio frmCartorio}
   with frmCartorio do
      begin
         {Altura do formulrio ser alterada para 177}
         Height := 177;
         {As 8 linhas abaixo so comandos que os respectivos objetos passam a ser invisveis}
         lblCartorio.Visible := False;
         lblContato.Visible := False;
         lblTelefone.Visible := False;
         EditCartorio.Visible := False;
         EditContato.Visible := False;
         mskTelefone.Visible := False;
         btnOk.Visible := False;
         btnCancelar.Visible := False;
         {As 5 linhas abaixo so comandos que habilitam os respectivos objetos}
         dbgCartorio.Enabled := True;
         btnIncluir.Enabled := True;
         btnEditar.Enabled := True;
         btnDeletar.Enabled := True;
         btnSair.Enabled := True;
      end;
end;

{Esta procedure ser executada quando ocorrer o evento Click no boto btnCancelar}
procedure TfrmCartorio.btnCancelarClick(Sender: TObject);
begin
   {Inclui um texto na barra de ttulo}
   Self.Caption := 'Cartrio';
   {Cancela a incluso ou a edio da tabela do objeto tblCartorio}
   Self.tblCartorio.Cancel;
   {Roda a procedure FechaForm}
   Self.FechaForm(frmCartorio);
end;

{Esta procedure ser Executada quando ocorrer o evento Click no boto btnSair}
procedure TfrmCartorio.btnSairClick(Sender: TObject);
begin
   {Fecha o formulrio frmCartorio}
   Self.Close;
end;

{Esta procedure ser executada quando ocorrer o evento Click no boto btnOk}
procedure TfrmCartorio.btnOkClick(Sender: TObject);
begin
   {Ser mostrada uma mensagem pedindo a confirmao da incluso}
   If Application.MessageBox('Confirma a Incluso ou Alterao deste Cartrio?',
      'Confirmao', mb_YesNo + mb_IconQuestion) = idYes then
      begin
         {Caso a incluso seja confirmada, ento ser gravado um novo Cartrio}
         Self.tblCartorio.Post;
         {Executa a procedure fechaForm}
         Self.fechaForm(frmCartorio);
      end;
end;

{Esta procedure ser executada quando ocorrer o evento Click no boto btnEditar}
procedure TfrmCartorio.btnEditarClick(Sender: TObject);
begin
   {Inclui um texto na Barra de Ttulo do formulrio}
   Self.Caption := 'Editar Cartrio';
   {Coloca a tabela do objeto tblCartorio no modo de edio}
   Self.tblCartorio.Edit;
   {Coloca o contedo do objeto EditTelefone para o objeto mskTelefone}
   Self.mskTelefone.Text := Self.EditTelefone.Text;
   {Executa a procedure AbreForm}
   Self.AbreForm(frmCartorio);
end;

{Esta procedure ser executada quando ocorrer o evento Click no boto btnDeletar}
procedure TfrmCartorio.btnDeletarClick(Sender: TObject);
begin
   {Ser mostrada uma mensagem pedindo a confirmao da excluso}
   If Application.MessageBox('Confirma a Excluso deste Cartrio?', 'Confirmao',
   mb_YesNo + mb_IconQuestion) = idYes then
      begin
      {Aqui ser feito um teste, se ocorrer um erro do tipo EDBEngineError, um erro
      que ocorre quando existe uma integridade referencial, ou seja, no se pode
      excluir um Cartrio que tenha(m) ttulos(s) enviado(s), ento ser mostrada uma
      mensagem que avisa o usurio da impossibilidade da excluso}
      	try
         	{Caso a excluso seja confirmada, ento este Cartrio ser excluido}
         	Self.tblCartorio.Delete;
         except
         	on EDBEngineError do
            	Application.MessageBox('Existe(m) Remessa(s) de Ttulo(s) para '+
               'este Cartrio.' + Chr(13) + 'No  possvel fazer a excluso',
               'Erro', mb_Ok + mb_IconError);
         end;
      end;
end;

end.
