unit ChequePre;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, DBCtrls, Db, DBTables, ExtCtrls, Buttons;

type
  TfrmChequePre = class(TForm)
    tblChequePre: TTable;
    dtsChequePre: TDataSource;
    tblCliente: TTable;
    dtsCliente: TDataSource;
    EditCGC: TDBEdit;
    tblClienteRegistro: TAutoIncField;
    tblClienteCliente: TStringField;
    tblClienteEndereco: TStringField;
    tblClienteCidade: TStringField;
    tblClienteEstado: TStringField;
    tblClienteCep: TStringField;
    tblClienteCgc: TStringField;
    tblClienteTelefone: TStringField;
    tblClienteRamal: TStringField;
    tblClienteContato: TStringField;
    tblClienteInscEst: TStringField;
    tblClienteInternet: TStringField;
    tblClienteDataHora: TDateTimeField;
    tblChequePreBanco: TStringField;
    tblChequePreAgencia: TStringField;
    tblChequePreContaCorrente: TStringField;
    tblChequePreValor: TCurrencyField;
    tblChequePreDescricao: TStringField;
    dbcblCliente: TDBLookupComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    EditNumCheque: TDBEdit;
    Label4: TLabel;
    mskEmissao: TMaskEdit;
    Label5: TLabel;
    EditLancamento: TDBEdit;
    mskLancamento: TMaskEdit;
    Label6: TLabel;
    mskDeposito: TMaskEdit;
    EditEmissao: TDBEdit;
    EditDeposito: TDBEdit;
    tblChequePreEmissao: TDateField;
    tblChequePreLancamento: TDateField;
    tblChequePreDeposito: TDateField;
    Label7: TLabel;
    EditValor: TDBEdit;
    Label8: TLabel;
    EditDescricao: TDBEdit;
    Panel1: TPanel;
    dblcbBanco: TDBLookupComboBox;
    tblBanco: TTable;
    dtsBanco: TDataSource;
    tblAgencia: TTable;
    dtsAgencia: TDataSource;
    tblBancoBanco: TStringField;
    tblBancoNome: TStringField;
    tblConta: TTable;
    dtsConta: TDataSource;
    dblcbAgencia: TDBLookupComboBox;
    dblcbConta: TDBLookupComboBox;
    tblAgenciaAgencia: TStringField;
    tblAgenciaBanco: TStringField;
    tblAgenciaNome: TStringField;
    tblAgenciaEndereco: TStringField;
    tblAgenciaGerente: TStringField;
    tblAgenciaTelefone: TStringField;
    tblAgenciaRamal: TStringField;
    tblAgenciaFax: TStringField;
    tblAgenciaInternet: TStringField;
    tblAgenciaDataHora: TDateTimeField;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    btnOk: TBitBtn;
    btnCancelar: TBitBtn;
    btnSair: TBitBtn;
    cbContinuo: TCheckBox;
    tblChequePreCpfCgc: TStringField;
    tblChequePreNumCheque: TStringField;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure dbcblClienteClick(Sender: TObject);
    procedure mskEmissaoChange(Sender: TObject);
    procedure mskLancamentoChange(Sender: TObject);
    procedure mskDepositoChange(Sender: TObject);
    procedure dblcbBancoClick(Sender: TObject);
    procedure dblcbAgenciaClick(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
    procedure btnCancelarClick(Sender: TObject);
    procedure btnSairClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmChequePre: TfrmChequePre;

implementation

uses MenuPri;

{$R *.DFM}

{Esta procedure ser executada quando ocorrer o evento Create do formulrio frmChequePre}
procedure TfrmChequePre.FormCreate(Sender: TObject);
begin
   {Todas as linhas abaixo entre begin e end pertencem ao formulrio frmChequePre,
   comandos que abrem as respectivas tabelas e coloca a tabela ChequePre em modo
   de incluso}
   With frmChequePre do
      begin
         tblCliente.Open;
         tblChequePre.Open;
         tblBanco.Open;
         tblAgencia.Open;
         tblConta.Open;
         tblChequePre.Append;
      end;
end;

{Esta procedure ser executada quando ocorrer o evento Close do formulrio frmChequePre}
procedure TfrmChequePre.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
   {Todas as linhas abaixo entre begin e end pertencem ao formulrio frmChequePre,
   comandos que fecham as respectivas tabelas}
   With frmChequePre do
      begin
         tblCliente.Close;
         tblChequepre.Close;
         tblBanco.Close;
         tblAgencia.Close;
         tblConta.Close;
      end;
   {Habilita a opo Cheque Pr-Datado do menu Contas a Receber}
   frmMenuPri.ChequePrDatado1.Enabled := True;
   {The form is closed and all allocated memory for the form is freed}
   Action := CaFree;
end;

{Esta procedure ser executada quando ocorrer o evento Click do objeto
DBLookupComboBox dbcblCliente}
procedure TfrmChequePre.dbcblClienteClick(Sender: TObject);
begin
   {Inclui no objeto EditCgc o nmero do cgc da empresa selecionada}
   Self.EditCgc.Text := Self.tblClienteCgc.Text;
   {Inclui na barra de ttulo uma string + o nome do cliente selecionado}
   Self.Caption := 'Cadastro de Cheque Pr - ' + Self.tblClienteCliente.text;
end;

{Esta procedure ser executada quando ocorrer o evento Change do objeto mskEmissao}
procedure TfrmChequePre.mskEmissaoChange(Sender: TObject);
begin
   {Inclui no objeto EditEmissao o contedo do objeto mskEmissao}
   EditEmissao.Text := mskEmissao.Text;
end;

{Esta procedure ser executada quando ocorrer o evento Change do objeto mskLancamento}
procedure TfrmChequePre.mskLancamentoChange(Sender: TObject);
begin
   {Inclui no objeto EditLancamento o contedo do objeto mskLancamento}
   EditLancamento.Text := mskLancamento.Text;
end;

{Esta procedure ser executada quando ocorrer o evento Change do objeto mskDeposito}
procedure TfrmChequePre.mskDepositoChange(Sender: TObject);
begin
   {Inclui no objeto EditDeposito o contedo do objeto mskDeposito}
   EditDeposito.Text := mskDeposito.Text;
end;

{Esta procedure ser executada quando ocorrer o evento Click do objeto dblcbBanco}
procedure TfrmChequePre.dblcbBancoClick(Sender: TObject);
begin
   With frmChequePre do
      begin
         {Fecha a tabela Agencia}
         tblAgencia.Close;
         {Fecha a tabela Conta}
         tblConta.Close;
         {Filtra agncia(s) do banco selecionado}
         tblAgencia.Filter := 'Banco = ' + tblBancoBanco.Text;
         tblAgencia.Filtered := True;
         {Habilita o objeto dblcbAgencia}
         dblcbAgencia.Enabled := True;
         {Abre a tabela agencia}
         tblAgencia.Open;
      end;
end;

{Esta procedure ser executa quando ocorrer o evento Click do objeto dblcbAgencia}
procedure TfrmChequePre.dblcbAgenciaClick(Sender: TObject);
begin
   With frmChequePre do
      begin
         {Fecha a tabela conta}
         tblConta.Close;
         {Filtra Conta(s) da agencia selecionada}
         tblConta.Filter := 'Agencia = ' + tblAgenciaAgencia.Text;
         tblConta.Filtered := True;
         {Habilita o objeto dblcbConta}
         dblcbConta.Enabled := True;
         {Abre a tabela Conta}
         tblConta.Open;
      end;
end;


{Esta procedure ser executada quando ocorrer o evento Click do boto btnOK}
procedure TfrmChequePre.btnOkClick(Sender: TObject);
begin
   {Ser mostrada uma mensagem pedindo a confirmao da incluso}
   If Application.MessageBox('Confirma o Cadastro deste Cheque Pr-Datado?',
      'Confirmao', mb_YesNo + mb_IconQuestion) = idYes then
      begin
         {Caso a incluso seja confirmada, ento o cheque ser cadastrado}
         Self.tblChequePre.Post;
         {Se o objeto CheckBox cbContinuo estiver selecionado a tabela ChequePre
         prepara para uma nova incluso}
         if cbContinuo.Checked = True then
            begin
               tblChequePre.Append;
               Self.mskEmissao.Text := '';
               Self.mskLancamento.Text := '';
               Self.mskDeposito.Text := '';
            end
         else
            {Caso contrrio, fecha o formulrio}
            Self.Close;
      end;
end;

{Esta procedure ser executada quando ocorrer o evento Click do boto btnCancelar}
procedure TfrmChequePre.btnCancelarClick(Sender: TObject);
begin
   {Cancela a incluso do cadastro do cheque pr-datado}
   Self.tblChequePre.Cancel;
   {Coloca a tabela ChequePre em modo de incluso}
   Self.tblChequePre.Append;
   {Limpa os contedos dos objetos abaixo}
   Self.mskEmissao.Text := '';
   Self.mskLancamento.Text := '';
   Self.mskDeposito.Text := '';
end;

{Esta procedure ser executada quando ocorrer o evento Click do boto btnSair}
procedure TfrmChequePre.btnSairClick(Sender: TObject);
begin
   {Cancela a incluso do cadastro do cheque Pr-Datado}
   Self.tblChequepre.Cancel;
   {Fecha o formulrio frmChequePre}
   Self.Close;
end;

end.
