unit Cliente;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls, Dialogs,
  StdCtrls, Forms, DBCtrls, DB, DBTables, Mask, ExtCtrls, Buttons;

type
  TfrmCliente = class(TForm)
    Panel2: TPanel;
    ScrollBox: TScrollBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    EditCliente: TDBEdit;
    EditEndereco: TDBEdit;
    EditCidade: TDBEdit;
    EditEstado: TDBEdit;
    EditCep: TDBEdit;
    EditCgc: TDBEdit;
    EditTelefone: TDBEdit;
    EditRamal: TDBEdit;
    EditContato: TDBEdit;
    EditInscEst: TDBEdit;
    EditInternet: TDBEdit;
    EditDataHora: TDBEdit;
    dtsCliente: TDataSource;
    tblCliente: TTable;
    btnGravar: TBitBtn;
    btnDeletar: TBitBtn;
    btnSair: TBitBtn;
    mskCGC: TMaskEdit;
    mskTelefone: TMaskEdit;
    mskCep: TMaskEdit;
    mskInscEst: TMaskEdit;
    dbeRegistro: TDBEdit;
    tblClienteRegistro: TAutoIncField;
    tblClienteCliente: TStringField;
    tblClienteEndereco: TStringField;
    tblClienteCidade: TStringField;
    tblClienteEstado: TStringField;
    tblClienteCep: TStringField;
    tblClienteCgc: TStringField;
    tblClienteTelefone: TStringField;
    tblClienteRamal: TStringField;
    tblClienteContato: TStringField;
    tblClienteInscEst: TStringField;
    tblClienteInternet: TStringField;
    tblClienteDataHora: TDateTimeField;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnGravarClick(Sender: TObject);
    procedure btnSairClick(Sender: TObject);
    procedure btnDeletarClick(Sender: TObject);
    procedure mskCepChange(Sender: TObject);
    procedure mskCGCChange(Sender: TObject);
    procedure mskTelefoneChange(Sender: TObject);
    procedure mskInscEstChange(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  frmCliente: TfrmCliente;

implementation

uses MenuCliente;

{$R *.DFM}

{Esta Procedure ser executada quando ocorrer o evento create do formulrio frmCliente}
procedure TfrmCliente.FormCreate(Sender: TObject);
begin
	{Ativar o objeto Table tblCliente}
	tblCliente.Open;
   {Se o Tag do frmMenuCli for 1 (editar), ento a condio ser verdadeira}
	if frmMenuCli.Tag = 1 then
   	begin
      	{Comando para filtrar cliente que foi selecionado no frmMenuCli no objeto
         dbGridCliente}
 			tblCliente.Filter := 'Registro = ' + (frmMenuCli.dbGridCliente.Columns.Items[0].Field.Text);
         {Aciona o filtro}
         tblCliente.Filtered := True;
         {Os prximos quatro comandos funciona para colar as informaes da tabela
         de clientes para as respectivas mscaras}
         mskCGC.Text := EditCGC.Text;
         mskCep.Text := EditCep.text;
         mskTelefone.text := EditTelefone.Text;
         mskInscEst.text := EditInscEst.Text;
         {Coloca os campos do formulrio frmCliente em modo de edio}
         Self.tblCliente.Edit;
      end
   else
   	{Se a condio for falsa, ento coloca os campos em modo de incluso}
		Self.tblCliente.Append;
end;

{Esta Procedure ser executada quando ocorrer o evento Close do formulrio frmCliente}
procedure TfrmCliente.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	{Desabilita o comando filtrar cliente}
	tblCliente.Filtered := False;
   {Desativa o objeto Table tblCliente}
	Self.tblCliente.Close;
   {Habilita o boto Deletar deste formulrio}
   Self.btnDeletar.Enabled := True;
   {Aciona a procedure SqlMenuCliente do formulrio frmMenuCli}
   frmMenuCli.SqlMenuCliente(frmMenuCli);
   {Retorna o Tag do frmMenuCli para 0, ou seja para incluso de Clientes}
   frmMenuCli.Tag := 0;
   {Destroi o formulrio frmCliente e libera a menria alocada}
   Action := CaFree;
   {Comando para habilitar o formulrio frmMenuCliente}
   frmMenuCli.Enabled := True;
end;

{Esta Procedure ser executada quando ocorrer o evento Click do boto Gravar}
procedure TfrmCliente.btnGravarClick(Sender: TObject);
begin
	{Se o objeto DBEdit, onde digitamos a Razo Social do Cliente estiver vazia,
   ento esta condio ser verdadeira}
	if EditCliente.Text = '' then
   	begin
      	{Mostra uma mensagem informando que no foi digitado o nome do cliente}
         Application.MessageBox('Digite a Razo Social do Cliente', 'Informao', mb_Ok + mb_IconInformation);
         {Coloca o foco no campo cliente, preparando-o para ser digitado}
         EditCliente.SetFocus;
      end
   {Se a condio anterior for falsa, ento estes comandos abaixo sero utilizados}
   else
   	begin
      	{Faa um novo teste para verificar se o endereo foi digitado}
         if EditEndereco.Text = '' then
				begin
            	{Se a condio anterior for verdadeira, ento mostra uma mensagem
               de alertando para o fato}
               Application.MessageBox('Digite o Endereo do Cliente', 'Informao', mb_Ok + mb_IconInformation);
               {Coloca o foco sobre o objeto testado, para facilitar a digitao}
               EditEndereco.SetFocus;
      		end
         {Se a condio anterior for falsa, ento}
         else
      		begin
               {Outra condio para testar se o campo CGC foi digitado}
               if EditCgc.Text = '' then
   					begin
            			{Mostra uma mensagem informando que o campo CGC no foi digitado}
      					Application.MessageBox('Digite o C.G.C. do Cliente', 'Informao', mb_Ok + mb_IconInformation);
               		{Coloca o foco neste campo, para facilitar a digitao}
         				mskCgc.SetFocus;
      				end
            end;
      end;
   {Uma nova condio para testar se os trs campos requeridos esto com dados digitados}
	if (EditCliente.Text <> '') and (EditCgc.Text <> '') and (EditEndereco.Text <> '') then
   	begin
      	{Se a condio anterior for verdadeira, ento ser mostrado uma mensagem,
         onde o usurio decidir pela confirmao ou no da incluso deste Cliente}
			if Application.MessageBox('Confirma a Incluso ou a Alterao deste Cliente?', 'Confirmao',
   		mb_YesNo + mb_ICONQUESTION) = idYes then
         	begin
            	{Comando para gravar a data e a hora do cadastro}
            	EditDataHora.Text := DateTimeToStr(now);
         		{Se o usurio confirmar clicando o boto OK, ento ser gravado o novo Cliente}
         		Self.tblCliente.Post;
            end
         else
         	{Se o usurio clicar no boto NO, ento este novo cliente no ser gravado}
         	Self.tblCliente.Cancel;
		{Comando para fechar o formulrio frmCliente}
      Self.Close;
		end;
end;

{Esta Procedure ser executada quando ocorrer o evento Click do boto btnSair}
procedure TfrmCliente.btnSairClick(Sender: TObject);
begin
	{Cancela a incluso ou a edio de clientes}
	Self.tblCliente.Cancel;
   {Comando para fechar o formulrio frmCliente}
	Self.Close;
	{Aciona a procedure SqlMenuCliente do formulrio frmMenuCli}
   frmMenuCli.SqlMenuCliente(frmMenuCli);
end;

{Esta procedure ser executada quando ocorrer o evento Click do boto btnDeletar}
procedure TfrmCliente.btnDeletarClick(Sender: TObject);
begin
	{Ser mostrado uma mensagem para confirmar a excluso de um cliente}
	if Application.MessageBox ('Confirma a Excluso deste Cliente?', 'Confirmao',
    mb_YesNo + mb_ICONQUESTION) = mrYes then
   	{Se for confirmada a excluso, ento ser o cliente ser excluido da tabela}
   	Self.tblCliente.Delete;
   {Comando para fechar o formulrio frmCliente}
	Self.Close;
end;

{Esta procedure ser executada quando ocorrer o evento Change do objeto mskCep}
procedure TfrmCliente.mskCepChange(Sender: TObject);
begin
	{Comando para copiar o contedo do objeto mskCep.Text para o objeto DBEdit EditCep.Text}
	EditCep.Text := Self.mskCep.Text;
end;

{Esta procedure ser executada quando ocorrer o evento Change do objeto mskCGC}
procedure TfrmCliente.mskCGCChange(Sender: TObject);
begin
	{Comando para copiar o contedo do objeto mskCGC.Text para o objeto DBEdit EditCgc.Text}
  	EditCgc.Text := Self.mskCGC.Text;
end;

{Esta procedure ser executada quando ocorrer o evento Change do objeto mskTelefone}
procedure TfrmCliente.mskTelefoneChange(Sender: TObject);
begin
	{Comando para copiar o contedo do objeto mskTelefone.Text para o objeto DBEdit EditTelefone.Text}
	EditTelefone.Text := mskTelefone.Text;
end;

{Esta procedure ser executada quando ocorrer o evento Change do objeto mskInscEst}
procedure TfrmCliente.mskInscEstChange(Sender: TObject);
begin
	{Comando para copiar o contedo do objeto mskInscEst.Text para o objeto DBEdit EditInscEst.Text}
	EditInscEst.Text := mskInscEst.Text;
end;

end.
