unit Despesa;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Mask, DBCtrls, ExtCtrls, Menus, Db, DBTables, Grids,
  DBGrids;

type
  TfrmDespesa = class(TForm)
    dbgDespesa: TDBGrid;
    tblDespesa: TTable;
    dtsDespesa: TDataSource;
    tblDespesaDespesa: TAutoIncField;
    tblDespesaLancamento: TFloatField;
    tblDespesaDataLanc: TDateTimeField;
    tblDespesaPrevPagto: TDateField;
    tblDespesaValorPrevisto: TCurrencyField;
    mmDespesa: TMainMenu;
    Cadastro1: TMenuItem;
    mmInclusao: TMenuItem;
    mmExclusao: TMenuItem;
    mmEdicao: TMenuItem;
    Panel1: TPanel;
    dbeLancamento: TDBEdit;
    dbeValorPrevisto: TDBEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    dbeDescricao: TDBEdit;
    lblTitulo: TLabel;
    mskDataPagto: TMaskEdit;
    btnOk: TBitBtn;
    btnCancelar: TBitBtn;
    btnSair: TBitBtn;
    dbePrevPagto: TDBEdit;
    dbeDataLanc: TDBEdit;
    tblDespesaDescricao: TStringField;
    N1: TMenuItem;
    mmFim: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure AbreForm(Sender: TObject);
    procedure FechaForm(Sender: TObject);
    procedure mmInclusaoClick(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
    procedure mskDataPagtoChange(Sender: TObject);
    procedure btnCancelarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnSairClick(Sender: TObject);
    procedure mmEdicaoClick(Sender: TObject);
    procedure mmExclusaoClick(Sender: TObject);
    procedure mmFimClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmDespesa: TfrmDespesa;

implementation

uses MenuPri;

{$R *.DFM}

{Esta procedure ser executada quando ocorrer o evento Create do formulrio frmDespesa}
procedure TfrmDespesa.FormCreate(Sender: TObject);
begin
   {Abre a tabela de despesa}
   Self.tblDespesa.Open;
end;

{Esta procedure ser executada quando for acionada a partir de um comando da fonte}
procedure TfrmDespesa.AbreForm(Sender: TObject);
begin
   With frmDespesa do
      begin
         {Aumenta a largura dor formulrio}
         Height := 306;
         {Todos os objetos abaixo ficam visveis}
         lblTitulo.Visible := True;
         Panel1.Visible := True;
         btnOk.Visible := True;
         btnCancelar.Visible := True;
         btnSair.Visible := True;
         {Desabilita o objeto Grid dbgDespesa}
         dbgDespesa.Enabled := False;
      end;
end;

{Esta procedure ser executada quando for acionada a partir de um comando da fonte}
procedure TfrmDespesa.FechaForm(Sender: TObject);
begin
   With frmDespesa do
      begin
         {Habilita o objeto Grid dbgDespesa}
         dbgDespesa.Enabled := True;
         {Diminui a largura do formulrio}
         Height := 176;
         {Todos os objetos abaixo ficam ivisveis}
         lblTitulo.Visible := False;
         Panel1.Visible := False;
         btnOk.Visible := False;
         btnCancelar.Visible := False;
         btnSair.Visible := False;
         {Habilita as opes Incluso, Edio e Excluso do menu Despesas}
         mmInclusao.Enabled := True;
         mmEdicao.Enabled := True;
         mmExclusao.Enabled := True;
      end;
end;

{Esta procedure ser executada ao selecionar a opo incluso do menu despesa}
procedure TfrmDespesa.mmInclusaoClick(Sender: TObject);
begin
   {Roda a procedure AbreForm}
   Self.AbreForm(frmDespesa);
   {Deixa o contedo do objeto mskDataPagto em branco}
   Self.mskDataPagto.Text := '';
   {Coloca o foco no objeto dbeLancamento}
   Self.dbeLancamento.SetFocus;
   {Inclui uma string no objeto label lblTitulo}
   Self.lblTitulo.Caption := 'Incluso de Despesa';
   {Desabilita as opes Incluso, Edio e Excluso do Menu Despesas}
   Self.mmInclusao.Enabled := False;
   Self.mmExclusao.Enabled := False;
   Self.mmEdicao.Enabled := False;
   {Coloca a tabela de despesa em modo de incluso}
   Self.tblDespesa.Append;
end;

{Esta procedure ser executada quando ocorrer o evento click do boto btnOk}
procedure TfrmDespesa.btnOkClick(Sender: TObject);
begin
   {Condio para verificar a confirmao da incluso de uma nova despesa}
   if Application.MessageBox('Confirma a Incluso ou Alterao desta Despesa?', 'Confirmao',
   mb_YesNo + mb_IconInformation) = IdYes then
      {Verdadeira}
      begin
         {Inclui a data e hora no objeto dbeDataLanc}
         Self.dbeDataLanc.Text := DateTimeToStr(Now);
         {Grava as informaes na tabela de despesa}
         Self.tblDespesa.Post;
         {Apaga o contedo do objeto mskDataPagto}
         Self.mskDataPagto.Text := '';
      end
   {Falsa}
   else
      {Cancela a incluso da despesa}
      Self.tblDespesa.Cancel;
   {Roda a procedure FechaForm}
   Self.FechaForm(frmDespesa)
end;

{Esta procedure ser executada quando ocorrer o evento Change do objeto mskDataPagto}
procedure TfrmDespesa.mskDataPagtoChange(Sender: TObject);
begin
   {Transfere o contedo do objeto mskDataPagto para dbePrevPagto}
   Self.dbePrevPagto.Text := mskDataPagto.Text;
end;

{Esta procedure ser executada quando ocorrer o evento click do boto btnCancelar}
procedure TfrmDespesa.btnCancelarClick(Sender: TObject);
begin
   {Cancela a incluso ou alterao de despesa}
   Self.tblDespesa.Cancel;
   {Executa a procedure FechaForm}
   Self.FechaForm(frmDespesa);
end;

{Esta procedure ser executada quando ocorrer o evento Close do formulrio}
procedure TfrmDespesa.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   {Fecha a tabela de despesa}
   Self.tblDespesa.Close;
   {Fecha o formulrio e libera a memria alocada}
   Action := CaFree;
end;

{Esta procedure ser executada quando ocorrer o evento click do boto btnSair}
procedure TfrmDespesa.btnSairClick(Sender: TObject);
begin
   {Fecha o formulrio}
   Self.Close;
end;

{Esta procedure ser executada ao selecionar a opo edio do menu despesa}
procedure TfrmDespesa.mmEdicaoClick(Sender: TObject);
begin
   {Roda a procedure AbreForm}
   Self.AbreForm(frmDespesa);
   {Edita a despesa selecionada}
   Self.tblDespesa.Edit;
   {Inclui uma string no objeto label lblTitulo}
   Self.lblTitulo.Caption := 'Edio de Despesa';
   {Desabilita as opes Edio, Excluso e Incluso do menu Despesas}
   Self.mmEdicao.Enabled := False;
   Self.mmExclusao.Enabled := False;
   Self.mmInclusao.Enabled := False;
   {Transfere o contedo do objeto dbePrevPagto para mskDataPagto}
   Self.mskDataPagto.Text := Self.dbePrevPagto.Text;
end;

{Esta procedure ser executada ao selecionar a opo excluso do menu despesa}
procedure TfrmDespesa.mmExclusaoClick(Sender: TObject);
begin
   {Condio para verificar a confirmao da excluso da despesa}
   if Application.MessageBox('Confirma a Excluso desta Despesa?', 'Confirmao',
   mb_YesNo + mb_IconInformation) = IdYes then
      {Condio verdadeira, apaga a despesa selecionada}
      Self.tblDespesa.Delete
   else
      {Condio falsa, cancela a excluso}
      Self.tblDespesa.Cancel;
end;

{Esta procedure ser executada ao selecionar a opo Fim do menu despesa}
procedure TfrmDespesa.mmFimClick(Sender: TObject);
begin
	{Executa a procedure FechaForm}
	Self.FechaForm(frmDespesa);
   {Fecha o formulrio}
	Self.Close;
end;

end.
