unit Fornecedor;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls, Dialogs,
  StdCtrls, Forms, DBCtrls, DB, Buttons, Mask, DBTables, ExtCtrls;

type
  TfrmFornecedor = class(TForm)
    tblFornecedorRegistro: TAutoIncField;
    tblFornecedorFornecedor: TStringField;
    tblFornecedorEndereco: TStringField;
    tblFornecedorCidade: TStringField;
    tblFornecedorEstado: TStringField;
    tblFornecedorCep: TStringField;
    tblFornecedorCgc: TStringField;
    tblFornecedorInscEst: TStringField;
    tblFornecedorTelefone: TStringField;
    tblFornecedorRamal: TStringField;
    tblFornecedorInternet: TStringField;
    tblFornecedorPagto: TStringField;
    tblFornecedorDesconto: TStringField;
    tblFornecedorEntrega: TFloatField;
    tblFornecedorVendedor: TStringField;
    tblFornecedorDataHora: TDateTimeField;
    dtsFornecedor: TDataSource;
    Panel2: TPanel;
    tblFornecedor: TTable;
    ScrollBox: TScrollBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    EditRegistro: TDBEdit;
    EditFornecedor: TDBEdit;
    EditEndereco: TDBEdit;
    EditCidade: TDBEdit;
    EditEstado: TDBEdit;
    EditCep: TDBEdit;
    EditCgc: TDBEdit;
    EditInscEst: TDBEdit;
    EditTelefone: TDBEdit;
    EditRamal: TDBEdit;
    EditInternet: TDBEdit;
    EditPagto: TDBEdit;
    EditDesconto: TDBEdit;
    EditEntrega: TDBEdit;
    EditVendedor: TDBEdit;
    EditDataHora: TDBEdit;
    btnGravar: TBitBtn;
    btnDeletar: TBitBtn;
    btnSair: TBitBtn;
    mskCep: TMaskEdit;
    mskCgc: TMaskEdit;
    mskInscEst: TMaskEdit;
    mskTelefone: TMaskEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnGravarClick(Sender: TObject);
    procedure btnSairClick(Sender: TObject);
    procedure btnDeletarClick(Sender: TObject);
    procedure mskCepChange(Sender: TObject);
    procedure mskCgcChange(Sender: TObject);
    procedure mskTelefoneChange(Sender: TObject);
    procedure mskInscEstChange(Sender: TObject);

  private
    { private declarations }
  public
    { public declarations }
  end;

var
  frmFornecedor: TfrmFornecedor;

implementation

uses MenuForn, MenuCliente;

{$R *.DFM}

{Esta Procedure ser executada quando ocorrer o evento Create do formulrio frmFornecedor}
procedure TfrmFornecedor.FormCreate(Sender: TObject);
begin
	{Ativar o objeto Table tblCliente}
	tblFornecedor.Open;
   {Se o Tag do frmMenuForn for 1 (editar), ento a condio  verdadeira}
	if frmMenuForn.Tag = 1 then
   	begin
      	{Comando para filtrar cliente que foi selecionado no frmMenuForn no objeto
         dbGridFornecedor}
 			tblFornecedor.Filter := 'Registro = ' + (frmMenuForn.dbGridFornecedor.Columns.Items[0].Field.Text);
         {Aciona o filtro}
         tblFornecedor.Filtered := True;
         {Os prximos quatro comandos funciona para colar as informaes da tabela
         de clientes para as respectivas mscaras}
         mskCGC.Text := EditCGC.Text;
         mskCep.Text := EditCep.text;
         mskTelefone.text := EditTelefone.Text;
         mskInscEst.text := EditInscEst.Text;
         {Coloca os campos do formulrio frmCliente em modo de edio}
         Self.tblFornecedor.Edit;
      end
   else
   	{Se a condio for falsa, ento coloca os campos em modo de incluso}
		Self.tblFornecedor.Append;
end;

{Esta Procedure ser executada quando ocorrer o evento Close do formulrio frmFornecedor}
procedure TfrmFornecedor.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
	{Desabilita o comando filtrar Fornecedor}
	Self.tblFornecedor.Filtered := False;
   {Desativa o objeto Table tblFornecedor}
	Self.tblFornecedor.Close;
   {Habilita o boto Deletar deste formulrio}
   Self.btnDeletar.Enabled := True;
   {Aciona a procedure SqlMenuCliente do formulrio frmMenuForn}
   frmMenuForn.SqlMenuFornecedor(frmMenuForn);
   {Retorna o Tag do frmMenuCli para 0, ou seja para incluso de Clientes}
   frmMenuForn.Tag := 0;
   {Destroi o frmCliente}
   Action := CaFree;
end;

{Esta Procedure ser executada quando ocorrer o evento Click do boto btnGravar}
procedure TfrmFornecedor.btnGravarClick(Sender: TObject);
begin
	{Se o objeto DBEdit, onde digitamos a Razo Social do Cliente estiver vazia,
   ento esta condio ser verdadeira}
	if EditFornecedor.Text = '' then
   	begin
      	{Mostra uma mensagem informando que no foi digitado o nome do fornecedor}
      	Application.MessageBox('Digite a Razo Social do Fornecedor', 'Informao', mb_Ok + mb_IconInformation);
         {Coloca o foco no campo cliente, preparando-o para ser digitado}
         EditFornecedor.SetFocus;
      end
   {Se a condio anterior for falsa, ento estes comandos abaixo sero utilizados}
   else
   	begin
      	{Outra condio para testar se o campo CGC foi digitado}
   		if EditCgc.Text = '' then
				begin
            	{Mostra uma mensagem informando que o campo CGC no foi digitado}
      			Application.MessageBox('Digite o C.G.C. do Fornecedor', 'Informao', mb_Ok + mb_IconInformation);
               {Coloca o foco neste campo, para facilitar a digitao}
         		mskCgc.SetFocus;
      		end
         {Se a condio anterior for falsa, ento}
         else
      		begin
            	{Faa um novo teste para verificar se o endereo foi digitado}
   				if EditEndereco.Text = '' then
   					begin
                  	{Se a condio anterior for verdadeira, ento mostra uma mensagem
                     de alertando para o fato}
      					Application.MessageBox('Digite o Endereo do Fornecedor', 'Informao', mb_Ok + mb_IconInformation);
                     {Coloca o foco sobre o objeto testado, para facilitar a digitao}
         				EditEndereco.SetFocus;
      				end
            end;
      end;
   {Uma nova condio para testar se os trs campos requeridos esto com dados digitados}
	if (EditFornecedor.Text <> '') and (EditCgc.Text <> '') and (EditEndereco.Text <> '') then
   	begin
      	{Se a condio anterior for verdadeira, ento ser mostrado uma mensagem,
         onde o usurio decidir pela confirmao ou no da incluso deste Fornecedor}
			if Application.MessageBox('Confirma a Incluso ou a Alterao deste Fornecedor?', 'Confirmao',
   		mb_YesNo + mb_IconQuestion) = idYes then
         	begin
            	{Comando para gravar a data e a hora do cadastro}
            	EditDataHora.Text := DateTimeToStr(now);
         		{Se o usurio confirmar clicando o boto OK, ento ser gravado o novo Fornecedor}
         		Self.tblFornecedor.Post;
            end
         else
         	{Se o usurio clicar no boto No, ento este novo cliente no ser gravado}
         	Self.tblFornecedor.Cancel;
		{Comando para fechar o formulrio frmCliente}
      Self.Close;
		end;
end;

{Esta Procedure ser executada quando ocorrer o evento Click do boto btnSair}
procedure TfrmFornecedor.btnSairClick(Sender: TObject);
begin
	{Cancela a incluso ou a edio de clientes}
	Self.tblFornecedor.Cancel;
   {Comando para fechar o formulrio frmCliente}
	Self.Close;
	{Aciona a procedure SqlMenuCliente do formulrio frmMenuCli}
   frmMenuForn.SqlMenuFornecedor(frmMenuForn);
end;

{Esta procedure ser executada quando ocorrer o evento Click do boto btnDeletar}
procedure TfrmFornecedor.btnDeletarClick(Sender: TObject);
begin
	{Ser mostrado uma mensagem para confirmar a excluso de um Fornecedor}
	if Application.MessageBox ('Confirma a Excluso deste Fornecedor?', 'Confirmao', mb_YesNo + mb_IconQuestion) = id_Yes then
   	{Se for confirmada a excluso, ento ser acionado este comando que ser retirado da tabela}
   	Self.tblFornecedor.Delete;
   {Comando para fechar o formulrio frmFornecedor}
	Self.Close;
end;

{Esta procedure ser executada quando ocorrer o evento Change do objeto mskCep}
procedure TfrmFornecedor.mskCepChange(Sender: TObject);
begin
	{Comando para copiar o contedo do objeto mskCep.Text para o objeto DBEdit EditCep.Text}
	EditCep.Text := Self.mskCep.Text;
end;


{Esta procedure ser executada quando ocorrer o evento Change do objeto mskCGC}
procedure TfrmFornecedor.mskCgcChange(Sender: TObject);
begin
	{Comando para copiar o contedo do objeto mskCGC.Text para o objeto DBEdit EditCgc.Text}
  	EditCgc.Text := Self.mskCGC.Text;
end;

{Esta procedure ser executada quando ocorrer o evento Change do objeto mskTelefone}
procedure TfrmFornecedor.mskTelefoneChange(Sender: TObject);
begin
	{Comando para copiar o contedo do objeto mskTelefone.Text para o objeto DBEdit EditTelefone.Text}
	EditTelefone.Text := mskTelefone.Text;
end;

{Esta procedure ser executada quando ocorrer o evento Change do objeto mskInscEst}
procedure TfrmFornecedor.mskInscEstChange(Sender: TObject);
begin
	{Comando para copiar o contedo do objeto mskInscEst.Text para o objeto DBEdit EditInscEst.Text}
	EditInscEst.Text := mskInscEst.Text;
end;

end.
