unit Lancamento;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls, Dialogs,
  StdCtrls, Forms, DBCtrls, DB, Mask, DBTables, Buttons, ExtCtrls;

type
  TfrmLancamento = class(TForm)
    dtsLancamento: TDataSource;
    tblLancamento: TTable;
    EditData: TDBEdit;
    EditDescricao: TDBEdit;
    EditValor: TDBEdit;
    EditLancamento: TDBEdit;
    Label1: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    tblPlano: TTable;
    dtsPlano: TDataSource;
    btnOk: TBitBtn;
    pnCredito: TPanel;
    Label2: TLabel;
    dbcbCredito: TDBLookupComboBox;
    cbAtivo: TCheckBox;
    cbPassivo: TCheckBox;
    pnDebito: TPanel;
    Label3: TLabel;
    dbcbDebito: TDBLookupComboBox;
    lblDebito: TLabel;
    btnSair: TBitBtn;
    tblPlanoPlanoContas: TAutoIncField;
    tblPlanoConta: TStringField;
    tblPlanoSuperior: TStringField;
    tblPlanoDescricao: TStringField;
    tblPlanoConsolidacao: TBooleanField;
    tblLancamentoLancamento: TAutoIncField;
    tblLancamentoContaCredito: TFloatField;
    tblLancamentoContaDebito: TFloatField;
    tblLancamentoValor: TCurrencyField;
    tblLancamentoDescricao: TStringField;
    lblContaCred: TLabel;
    lblContaDeb: TLabel;
    tblLancamentoData: TDateField;
    tblLancamentoStatus: TStringField;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure dbcbCreditoMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure dbcbDebitoMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btnOkClick(Sender: TObject);
    procedure cbAtivoMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure cbPassivoMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btnSairClick(Sender: TObject);
    procedure dbcbCreditoClick(Sender: TObject);
    procedure dbcbDebitoClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  frmLancamento: TfrmLancamento;

implementation

uses MenuLancamento;

{$R *.DFM}

{Esta procedure ser executada quando ocorrer o evento Create deste formulrio}
procedure TfrmLancamento.FormCreate(Sender: TObject);
begin
   {Abre o objeto table tblLancamento}
   Self.tblLancamento.Open;
   {Abre o objeto table tblPlano}
   Self.tblPlano.Open;
end;

{Esta procedure ser executada quando ocorrer o evento Close deste formulrio}
procedure TfrmLancamento.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   {fecha o objeto table tblLancamento}
   Self.tblLancamento.Close;
   {fecha o objeto table tblPlano}
   Self.tblPlano.Close;
   {The form is closed and all allocated memory for the form is freed}
   Action := CaFree;
   {Habilita o formulrio frmMenuLancamento}
   frmMenuLancamento.Enabled := True;
end;

{Esta procedure ser ativada quando ocorrer o evento MouseDown no objeto
dbLookupComboBox dbcbCredito}
procedure TfrmLancamento.dbcbCreditoMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   {Desativa a propriedade de filtragem do objeto table tblPlano}
   Self.tblPlano.Filtered := False;
      {Condio para verificar se o objeto CheckBox cbAtivo est assinalado}
      if cbAtivo.Checked = True then
         {Caso a condio seja verdadeira, ento filtrar as contas que iniciam
         com 1, ou seja ativo}
         Self.tblPlano.Filter := 'conta = ''1*'''
      else
         {Caso contrrio, filtrar as contas que iniciam com 2, ou seja passivo}
         Self.tblPlano.Filter := 'conta = ''2*''';
   {Ativar o filtro}
   Self.tblPlano.Filtered := True;
end;

{Esta procedure ser executada quando ocorrer o evento MouseDown no objeto
dbLookupComboBox dbcbCredito}
procedure TfrmLancamento.dbcbDebitoMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   {Desativa a propriedade de filtragem do objeto table tblPlano}
   Self.tblPlano.Filtered := False;
      {Condio para verificar se o objeto CheckBox cbAtivo est assinalado}
      if cbAtivo.Checked = True then
         {Caso a condio seja verdadeira, ento filtrar as contas que iniciam com 2}
         Self.tblPlano.Filter := 'conta = ''2*'''
      else
         {Caso contrrio, filtrar as contas que iniciam com 1}
         Self.tblPlano.Filter := 'conta = ''1*''';
   {Ativar o filtro}
   Self.tblPlano.Filtered := True;
end;

{Esta procedure ser executada quando ocorrer o evento click do boto btnOk}
procedure TfrmLancamento.btnOkClick(Sender: TObject);
begin
   {Condio para verificar a confirmao da incluso de um novo regitro}
   if Application.MessageBox('Confirma a Incluso deste Lanamento?', 'Confirmao',
   mb_YesNo + mb_IconInformation) = IdYes then
      {boto sim}
      begin
         {Comando para gravar a data e a hora do cadastro}
         Self.EditData.Text := DateToStr(Date);
         {Grava um novo registro na tabela de Lanamento}
         Self.tblLancamento.Post;
      end
   else
      {Se o usurio clicar no boto no, ento no ser gravado o novo registro}
      Self.tblLancamento.Cancel;
   {habilita e desabilita o objeto Query sqlLancamento para atualizar os registros}
   frmMenuLancamento.sqlLancamento.Active := False;
   frmMenuLancamento.sqlLancamento.Active := True;
   {Fecha o formulrio}
   Self.Close;
end;

{Esta procedure ser executada quando ocorrer o evento Click do objeto CheckBox cbAtivo}
procedure TfrmLancamento.cbAtivoMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   {Altera a cor da Font dos objetos que esto dentro do painel pnCredito para azul}
   pnCredito.Font.Color := clBlue;
   {Altera a cor da Font dos objetos que esto dentro do painel pnDebito para vermelho}
   pnDebito.Font.Color := clRed;
   {Altera a cor do objeto cbAtivo para azul}
   cbAtivo.Font.Color := clBlue;
   {Altera a cor do objeto cbPassivo para vermelho}
   cbPassivo.Font.Color := clRed;
   {Assinala o objeto CheckBox cbAtivo}
   cbAtivo.Checked;
   {Insere uma string no objeto Edit lblDebito}
   lblDebito.Caption := 'Passivo';
   {Condio para verificar se o objeto cbPassivo est assinalado}
   if cbPassivo.Checked then
      {Se for verdadeira, ento passa o objeto para o modo no assinalado}
      cbPassivo.Checked := False;
end;

{Esta procedure ser executada quando ocorrer o evento Click do objeto CheckBox cbPassivo}
procedure TfrmLancamento.cbPassivoMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   {Altera a cor da Font dos objetos que esto dentro do painel pnCredito para vermelho}
   pnCredito.Font.Color := clRed;
   {Altera a cor da Font dos objetos que esto dentro do painel pnDebito para azul}
   pnDebito.Font.Color := clBlue;
   {Altera a cor do objeto cbativo para azul}
   cbAtivo.Font.Color := clBlue;
   {Altera a cor do objeto cbPassivo para vermelho}
   cbPassivo.Font.Color := clRed;
   {Assinala o objeto CheckBox cbPassivo}
   cbPassivo.Checked;
   {Insere uma string no objeto Edit lblDebito}
   lblDebito.Caption := 'Ativo';
   {Condio para verificar se o objeto cbAtivo est assinalado}
   if cbAtivo.Checked then
      {Se for verdadeira, ento passa o objeto para o modo no assinalado}
      cbAtivo.Checked := False;
end;

{Esta procedure ser executada quando ocorrer o evento Click do boto btnSair}
procedure TfrmLancamento.btnSairClick(Sender: TObject);
begin
   {fecha o objeto table tblLancamento}
   Self.tblLancamento.Cancel;
   {Fecha o formulrio}
   Self.Close;
end;

{Esta procedure ser executada quando ocorrer o evento Click do objeto dbcbCredito}
procedure TfrmLancamento.dbcbCreditoClick(Sender: TObject);
begin
   {Insere no objeto label lblContaCred o nmero da conta selecionada}
   Self.lblContaCred.Caption := tblPlanoConta.Text;
end;

{Esta procedure ser executada quando ocorrer o evento Click do objeto dbcbDebito}
procedure TfrmLancamento.dbcbDebitoClick(Sender: TObject);
begin
   {Insere no objeto label lblContaDeb o nmero da conta selecionada}
   Self.lblContaDeb.Caption := tblPlanoConta.Text;
end;

end.
