unit LocCliente;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TfrmLocalizar = class(TForm)
    lblLocalizar: TLabel;
    txtLocalizar: TEdit;
    btnOk: TBitBtn;
    btnSair: TBitBtn;
    procedure btnOkClick(Sender: TObject);
    procedure btnSairClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmLocalizar: TfrmLocalizar;

implementation

uses MenuCliente, Cliente;

{$R *.DFM}

{Esta procedure ser executada quando ocorrer o evento click do boto btnOK}
procedure TfrmLocalizar.btnOkClick(Sender: TObject);
begin
	{Tag = 2, para localizar Clientes, no executa a procedure formAtivate
   do formulrio frmMenuCli}
   frmMenuCli.Tag := 2;
	with frmMenuCli.sqlMenuCli do
   	begin
      	{Comandos em SQL, para localizar um cliente que tenha pelo menos em uma parte
         do seu nome, o contedo do objeto txtLocalizar.Text}
         Close;
         SQL.Clear;
         SQL.Add('Select * from Cliente Where UPPER(Cliente) LIKE UPPER(''%'' + :1 + ''%'')');
         Params[0].AsString := Self.txtLocalizar.Text;
         Open;
      end;
      	{Caso no haja nenhum cliente com as caractersticas anteriores, ento
         a condio seguinte ser acionada}
      	if frmMenuCli.sqlMenuCli.RecordCount = 0 then
         	begin
            	{Aciona a procedure SqlMenuCliente do formulrio frmMenuCli}
					frmMenuCli.SqlMenuCliente(frmMenuCli);
               {Mostra uma mensagem, avisando para o usurio que o cliente no
               est cadastrdo e pede uma confirmao para cadastrar o novo cliente}
            	if Application.MessageBox('Empresa no cadastrado, cadastrar agora?',
               	'Confirmao', mb_YesNo + mb_ICONQUESTION) = mrYes then
                  begin
                  	{Se a condio anterior for verdadeira, ento abre-se o
                  	formulrio frmCliente para a incluso do novo cliente}
                     frmMenuCli.btnIncluirClick(frmMenuCli);
                     {Coloca o contedo do objeto edit txtLocalizar no objeto
                     dbEdit editCliente do formulrio frmCliente}
                     frmCliente.EditCliente.Text := Self.txtLocalizar.Text;
                  end;
            end;
	{Fecha o formulrio frmLocalizar}
   Self.Close;
   {Limpa o objeto txtLocalizar}
   Self.txtLocalizar.Text := '';
   {Atualiza a barra de ttulo do formulrio frmMenuCli}
   frmMenuCli.Caption := 'Total de Clientes Localizados  ' + intTostr(frmMenuCli.sqlMenuCli.RecordCount);
end;

{Esta procedure ser executada quando ocorrer o evento click boto btnSair}
procedure TfrmLocalizar.btnSairClick(Sender: TObject);
begin
	{Fecha o formulrio frmLocalizar}
	Self.Close;
end;

{Esta procedure ser executada quando ocorrer o evento close do formulrio frmLocalizar}
procedure TfrmLocalizar.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
	{Destroi o formulrio e libera a memria alocada}
   Action := CaFree;
end;

end.
