unit LocFornecedor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TfrmLocForn = class(TForm)
    Label1: TLabel;
    txtLocalizar: TEdit;
    btnOk: TBitBtn;
    btnSair: TBitBtn;
    procedure btnOkClick(Sender: TObject);
    procedure btnSairClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmLocForn: TfrmLocForn;

implementation

uses MenuForn, MenuCliente, Fornecedor;

{$R *.DFM}

{Esta procedure ser acionada quando o boto OK for clicado}
procedure TfrmLocForn.btnOkClick(Sender: TObject);
begin
   frmMenuForn.Tag := 2; {Tag para localizar Fornecedor}
	with frmMenuForn.sqlMenuForn do
   	begin
      	{Comandos em SQL, para localizar um Fornecedor que tenha pelo menos em uma parte
         do seu nome, o contedo do objeto txtLocalizar.Text}
         Close;
         SQL.Clear;
         SQL.Add('Select * from Fornecedor Where UPPER(Fornecedor) LIKE UPPER(''%'' + :1 + ''%'')');
         Params[0].AsString := Self.txtLocalizar.Text;
         Open;
      end;
      	{Caso no haja nenhum Fornecedor com as caractersticas anteriores, ento
         a condio seguinte ser acionada}
      	if frmMenuForn.sqlMenuForn.RecordCount = 0 then
         	begin
            	{Aciona a procedure SqlMenuCliente do formulrio frmMenuCli}
					frmMenuForn.SqlMenuFornecedor(frmMenuForn);
               {Mostra uma mensagem, avisando para o usurio que o Fornecedor no
               est cadastrdo e pede uma confirmao para cadastrar este Fornecedor}
            	if Application.MessageBox('Fornecedor no cadastrado, cadastrar agora?',
               	'Confirmao', mb_YesNo + mb_IconQuestion) = idYes then
                  begin
                  	{Se a condio anterior for verdadeira, ento abre-se o
                  	formulrio frmFornecedor para a incluso do novo cliente}
                  	frmMenuForn.btnIncluirClick(frmMenuCli);
                     {Coloca o contedo do objeto edit txtLocalizar no objeto
                     dbEdit editFornecedor do formulrio frmFornecedor}
                     frmFornecedor.EditFornecedor.Text := Self.txtLocalizar.Text;
                  end;
            end;
	{Fecha o formulrio frmLocalizar}
   Self.Close;
   {Limpa o objeto txtLocalizar}
   Self.txtLocalizar.Text := '';
   {Atualiza a barra de ttulo do formulrio frmMenuForn}
   frmMenuForn.Caption := 'Total de Fornecedor(es) Localizados  ' +
   intTostr(frmMenuForn.sqlMenuForn.RecordCount);
end;

{Esta procedure ser executada quando ocorrer o evento Click do formulrio frmLocalizar}
procedure TfrmLocForn.btnSairClick(Sender: TObject);
begin
	{Fecha o formulrio frmLocalizar}
	Self.Close;
end;

{Esta procedure ser executada quando ocorrerm o evento Close do formulrio frmLocalizar}
procedure TfrmLocForn.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   {Destroi o frmLocalizar}
   Action := CaFree;
end;

end.
