unit MenuCliente;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, DBCtrls, Grids, DBGrids, Db, DBTables, Buttons, ExtCtrls,
  Menus;

type
  TfrmMenuCli = class(TForm)
    Panel1: TPanel;
    dbGridCliente: TDBGrid;
    sqlMenuCli: TQuery;
    dtsMenuCli: TDataSource;
    btnIncluir: TBitBtn;
    btnEditar: TBitBtn;
    btnLocalizar: TBitBtn;
    btnSair: TBitBtn;
    btnRelatorio: TBitBtn;
    ppMenuCli: TPopupMenu;
    ppAlfa: TMenuItem;
    ppRegistro: TMenuItem;
    ppCidade: TMenuItem;
    N1: TMenuItem;
    ppSair: TMenuItem;
    procedure FormActivate(Sender: TObject);
    procedure btnLocalizarClick(Sender: TObject);
    procedure btnSairClick(Sender: TObject);
    procedure btnIncluirClick(Sender: TObject);
    procedure btnEditarClick(Sender: TObject);
    procedure SqlMenuCliente(Sender: TObject);
    procedure btnRelatorioClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ppAlfaClick(Sender: TObject);
    procedure ppRegistroClick(Sender: TObject);
    procedure ppCidadeClick(Sender: TObject);
    procedure ppSairClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMenuCli: TfrmMenuCli;

implementation

uses Cliente, LocCliente, RelCli, MenuPri;

{$R *.DFM}

{Esta procedure ser executada quando ocorrer o evento formActivate (formulrio
frmMenuCli for ativado}
procedure TfrmMenuCli.FormActivate(Sender: TObject);
begin
   {Condio para verificar se a Tag = 2 (localizar Clientes)}
   if Self.Tag <> 2 then {Se a Tag for diferente de 2}
   	begin
      	with frmMenuCli.sqlMenuCli do
         	begin
            	{Comandos em Sql para selecionar todos os campos e registros da tabela Cliente
               em ordem alfabtica do campo cliente}
               Close;
               SQL.Clear;
               SQL.Add('Select * from Cliente Order by Cliente');
               Open;
            end;
         {Comando para incluir uma string na barra de ttulo + a quantidade de Registros
         na tabela de Clientes}
         Self.Caption := 'Total de Clientes Cadastrados  ' + intTostr(sqlMenuCli.RecordCount);
         {Habilita o formulrio}
         Self.Enabled := True;
      end;
end;

{Esta procedure que ser executada quando ocorrer o evento Click do boto Localizar}
procedure TfrmMenuCli.btnLocalizarClick(Sender: TObject);
begin
	{Comandos para criar e mostrar o formulrio frmLocalizar}
	Application.CreateForm(TfrmLocalizar, frmLocalizar);
	frmLocalizar.Show;
end;

{Esta Procedure ser acionada quando o boto Sair for clicado}
procedure TfrmMenuCli.btnSairClick(Sender: TObject);
begin
	{Comandos para fechar o objeto Query sqlMenuCli e o Formulrio frmMenuCli}
   Self.sqlMenuCli.Close;
	Self.Close;
end;

{Esta Procedure ser acionada quando o boto Incluir for clicado}
procedure TfrmMenuCli.btnIncluirClick(Sender: TObject);
begin
	{Comando para criar o formulrio frmCliente}
	Application.CreateForm(TfrmCliente, frmCliente);
   {Comando para incluir uma string na barra de ttulo do formulrio frmCliente}
	frmCliente.Caption := 'Incluir Cliente';
   {Comando para mostrar o formulrio frmCliente}
	frmCliente.Show;
   {Comando para desabilitar o formulrio frmMenuCliente}
   Self.Enabled := False;
   {Comando para desabilitar o boto btnDeletar do formulrio frmCliente}
   frmCliente.btnDeletar.Enabled := false;
end;

{Esta Procedure ser acionada quando o boto Editar for clicado}
procedure TfrmMenuCli.btnEditarClick(Sender: TObject);
begin
   Self.Tag := 1; {Tag para editar}
	{Comandos para Criar, inserir uma string na barra de ttulo e mostrar o formulrio
   frmCliente}
	Application.CreateForm(TfrmCliente, frmCliente);
   {Comando para desabilitar o formulrio frmMenuCliente}
   Self.Enabled := False;
	{Comando para incluir uma string na barra de ttulo do formulrio frmCliente}
   frmCliente.Caption := 'Editar Cliente';
end;

{Esta procedure foi criada para ser acionada quando um comando acionar esta funo}
procedure TfrmMenuCli.SqlMenuCliente(Sender: TObject);
begin
	{O comando With esta sendo utilizado para evitar a repetio da momenclatura
   do formulrio frmMenuCli e do objeto Query sqlMenuCli}
	with frmMenuCli.sqlMenuCli do
   	begin
      	{Comando em linguagem SQL, selecionar todos os campos da tabela Cliente}
      	Close;
         SQL.Clear;
         SQL.Add('Select * from Cliente');
         Open;
      end;
end;

{Esta procedure ser acionada quando o boto Relatrio for clicado}
procedure TfrmMenuCli.btnRelatorioClick(Sender: TObject);
begin
	{Comandos para criar, atualizar e mostrar o relatrio do Cadastro de Clientes}
   Application.CreateForm(TQRMDRelCli, QRMDRelCli);
	QRMDRelCli.tblRelCli.Active := False;
	QRMDRelCli.tblRelCli.Active := True;
   QRMDRelCli.preview;
	QRMDRelCli.Destroy;
end;

{Procedure para quando o formulrio frmMenuCli for fechado}
procedure TfrmMenuCli.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   {Destroi o formulrio frmMenuCli}
   Action := CaFree;
   {Habilita o menu cadastro de clientes do fomrmulrio frmMenuPri}
   frmMenuPri.Clientes1.Enabled := True;
end;

{Procedure do objeto PopupMenu opo Ordem Alfabtica}
procedure TfrmMenuCli.ppAlfaClick(Sender: TObject);
begin
	With frmMenuCli.sqlMenucli do
   	begin
			{Comandos em Sql para selecionar todos os registros da tabela Cliente por ordem alfabtica}
   		Close;
   		SQL.Clear;
   		SQL.Add('Select * from Cliente Order by Cliente');
   		Open;
      end;
end;

{Procedure do objeto PopupMenu opo Ordem de Registro}
procedure TfrmMenuCli.ppRegistroClick(Sender: TObject);
begin
	With frmMenuCli.sqlMenucli do
   	begin
			{Comandos em Sql para selecionar todos os registros da tabela Cliente por ordem de registro}
   		Close;
   		SQL.Clear;
   		SQL.Add('Select * from Cliente Order by Registro');
   		Open;
      end;
end;

{Procedure do objeto PopupMenu opo Ordem de Cidade}
procedure TfrmMenuCli.ppCidadeClick(Sender: TObject);
begin
	With frmMenuCli.sqlMenucli do
   	begin
			{Comandos em Sql para selecionar todos os registros da tabela Cliente por ordem alfabtica da cidade}
   		Close;
   		SQL.Clear;
   		SQL.Add('Select * from Cliente Order by Cidade');
   		Open;
      end;
end;

procedure TfrmMenuCli.ppSairClick(Sender: TObject);
begin
	frmMenuCli.btnSairClick(frmMenuCli);
end;

end.
