unit MenuForn;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, Grids, DBGrids, StdCtrls, Buttons, Menus;

type
  TfrmMenuForn = class(TForm)
    dbGridFornecedor: TDBGrid;
    sqlMenuForn: TQuery;
    dtsMenuForn: TDataSource;
    sqlMenuFornRegistro: TIntegerField;
    sqlMenuFornFornecedor: TStringField;
    sqlMenuFornEndereco: TStringField;
    sqlMenuFornCidade: TStringField;
    sqlMenuFornEstado: TStringField;
    sqlMenuFornCep: TStringField;
    sqlMenuFornCgc: TStringField;
    sqlMenuFornInscEst: TStringField;
    sqlMenuFornTelefone: TStringField;
    sqlMenuFornRamal: TStringField;
    sqlMenuFornInternet: TStringField;
    sqlMenuFornPagto: TStringField;
    sqlMenuFornDesconto: TStringField;
    sqlMenuFornEntrega: TFloatField;
    sqlMenuFornVendedor: TStringField;
    sqlMenuFornDataHora: TDateTimeField;
    btnIncluir: TBitBtn;
    btnEditar: TBitBtn;
    btnLocalizar: TBitBtn;
    btnRelatorio: TBitBtn;
    btnSair: TBitBtn;
    ppMenuForn: TPopupMenu;
    ppAlfa: TMenuItem;
    ppRegistro: TMenuItem;
    ppCidade: TMenuItem;
    N1: TMenuItem;
    ppSair: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnSairClick(Sender: TObject);
    procedure btnIncluirClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btnEditarClick(Sender: TObject);
    procedure btnLocalizarClick(Sender: TObject);
    procedure btnRelatorioClick(Sender: TObject);
    procedure sqlMenuFornecedor(Sender: TObject);
    procedure ppAlfaClick(Sender: TObject);
    procedure ppRegistroClick(Sender: TObject);
    procedure ppCidadeClick(Sender: TObject);
    procedure ppSairClick(Sender: TObject);
    
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMenuForn: TfrmMenuForn;

implementation

uses Fornecedor, Cliente, MenuPri, LocFornecedor, LocCliente, RelForn;

{$R *.DFM}

{Esta procedure ser executada quando ocorrer o evento Close do formulrio frmMenuForn}
procedure TfrmMenuForn.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
   {Destri o formulrio frmMenuCli}
   Action := CaFree;
   {Habilita a opo Fornecedor  do menu cadastro do fomrmulrio frmMenuPri}
   frmMenuPri.Fornecedor1.Enabled := True;
end;

{Esta procedure ser executada quando ocorrer o evento Click do boto btnSair}
procedure TfrmMenuForn.btnSairClick(Sender: TObject);
begin
	{Comandos para fechar o objeto Query sqlMenuForn e o Formulrio frmMenuForn}
   Self.sqlMenuForn.Close;
	Self.Close;
end;

{Esta procedure ser executada quando ocorrer o evento Click do boto btnIncluir}
procedure TfrmMenuForn.btnIncluirClick(Sender: TObject);
begin
	{Comando para criar o formulrio frmFornecedor}
	Application.CreateForm(TfrmFornecedor, frmFornecedor);
   {Comando para incluir uma string na barra de ttulo do formulrio frmFornecedor}
	frmCliente.Caption := 'Incluir um Novo Fornecedor';
   {Comando para mostrar o formulrio frmFornecedor}
	frmFornecedor.Show;
   {Comando para desabilitar o boto btnDeletar do formulrio frmCliente}
   frmFornecedor.btnDeletar.Enabled := false;
end;

{Esta procedure ser executada quando ocorrer o evento Activate do formulrio frmMenuForn}
procedure TfrmMenuForn.FormActivate(Sender: TObject);
begin
   {Condio para verificar se a Tag = 2 (localizar Clientes)}
   if Self.Tag <> 2 then {Se a Tag for diferente de 2}
   	begin
      	{O comando With esta sendo utilizado para evitar a repetio da momenclatura
   		do formulrio frmMenuForn e do objeto Query sqlMenuForn}
      	with frmMenuForn.sqlMenuForn do
         	begin
            	{Comandos em Sql para selecionar todos os campos e registros da tabela Fornecedor}
            	Close;
               SQL.Clear;
               SQL.Add('Select * from Fornecedor Order By Fornecedor');
               Open;
            end;
         {Comando para incluir uma string na barra de ttulo + a quqntidade de Registros
         na tabela de Clientes}
         Self.Caption := 'Total de Fornecedores Cadastrados  ' + intTostr(sqlMenuForn.RecordCount);
         {Habilita o formulrio frmMenuForn}
         Self.Enabled := True;
      end;
end;

{Esta procedure ser executada quando ocorrer o evento Click do boto btnEditar}
procedure TfrmMenuForn.btnEditarClick(Sender: TObject);
begin
   Self.Tag := 1; {Tag para editar}
	{Comandos para Criar e inserir uma string na barra de ttulo do frmCliente}
	Application.CreateForm(TfrmFornecedor, frmFornecedor);
   frmFornecedor.Caption := 'Editar Fornecedor';
end;

{Esta procedure ser executada quando ocorrer o evento Click do boto btnLocalizar}
procedure TfrmMenuForn.btnLocalizarClick(Sender: TObject);
begin
	{Comandos para criar e mostrar o formulrio frmLocalizar}
	Application.CreateForm(TfrmLocForn, frmLocForn);
	frmLocForn.Show;
end;

{Esta procedure ser executada quando ocorrer o evento Click do boto btnRelatorio}
procedure TfrmMenuForn.btnRelatorioClick(Sender: TObject);
begin
	{Comandos para criar, atualizar e mostrar o relatrio do Cadastro de Fornecedores}
   Application.CreateForm(TQRMDRelForn, QRMDRelForn);
	QRMDRelForn.tblRelForn.Active := False;
	QRMDRelForn.tblRelForn.Active := True;
	QRMDRelForn.preview;
   QRMDRelForn.Destroy;
end;

{Esta procedure ser executada para ser acionada a partir de um comando na fonte}
procedure TfrmMenuForn.SqlMenuFornecedor(Sender: TObject);
begin
	{O comando With esta sendo utilizado para evitar a repetio da momenclatura
   do formulrio frmMenuForn e do objeto Query sqlMenuForn}
	with frmMenuForn.sqlMenuForn do
   	begin
      	{Comando em linguagem SQL, selecionar todos os campos da tabela Fornecedor,
         em ordem alfabtica do campo fornecedor}
      	Close;
         SQL.Clear;
         SQL.Add('Select * from Fornecedor Order By Fornecedor');
         Open;
      end;
end;

{Esta procedure ser executada quando ocorrer um evento Click na opo Ordem Alfabtica
do objeto PopupMenu ppMenuForn}
procedure TfrmMenuForn.ppAlfaClick(Sender: TObject);
begin
	{Executa a procedure sqlMenuFornecedor}
	frmMenuForn.SqlMenuFornecedor(frmMenuForn);
end;

{Esta procedure ser executada com evento da opo Ordem de Registro do objeto PopupMenu}
procedure TfrmMenuForn.ppRegistroClick(Sender: TObject);
begin
	{O comando With esta sendo utilizado para evitar a repetio da momenclatura
   do formulrio frmMenuForn e do objeto Query sqlMenuForn}
	with frmMenuForn.sqlMenuForn do
   	begin
      	{Comando em linguagem SQL, selecionar todos os campos da tabela Fornecedor,
         por ordem de Registro}
      	Close;
         SQL.Clear;
         SQL.Add('Select * from Fornecedor Order By Registro');
         Open;
      end;
end;

{Esta procedure ser executada com evento da opo Ordem de Cidade do objeto PopupMenu}
procedure TfrmMenuForn.ppCidadeClick(Sender: TObject);
begin
	{O comando With esta sendo utilizado para evitar a repetio da momenclatura
   do formulrio frmMenuForn e do objeto Query sqlMenuForn}
	with frmMenuForn.sqlMenuForn do
   	begin
      	{Comando em linguagem SQL, selecionar todos os campos da tabela Fornecedor,
         por ordem de Cidade}
      	Close;
         SQL.Clear;
         SQL.Add('Select * from Fornecedor Order By Cidade');
         Open;
      end;
end;

{Esta procedure ser executada com evento da opo Sair do objeto PopupMenu}
procedure TfrmMenuForn.ppSairClick(Sender: TObject);
begin
	{Comando para executar o evento Click do boto btnSair}
	frmMenuForn.btnSairClick(frmMenuForn);
end;

end.
