unit MenuLancamento;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, Grids, DBGrids, StdCtrls, Buttons;

type
  TfrmMenuLancamento = class(TForm)
    dbgLancamento: TDBGrid;
    sqlLancamento: TQuery;
    dtsLancamento: TDataSource;
    btnIncluir: TBitBtn;
    btnSair: TBitBtn;
    btnCancelar: TBitBtn;
    sqlLancamentoLancamento: TIntegerField;
    sqlLancamentoContaCredito: TFloatField;
    sqlLancamentoContaDebito: TFloatField;
    sqlLancamentoValor: TCurrencyField;
    sqlLancamentoDescricao: TStringField;
    sqlLancamentoDescricao_1: TStringField;
    sqlLancamentoDescricao_2: TStringField;
    sqlLancamentoStatus: TStringField;
    txtLancamento: TEdit;
    sqlLancamentoData: TDateField;
    procedure btnIncluirClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure btnCancelarClick(Sender: TObject);
    procedure dbgLancamentoCellClick(Column: TColumn);
    procedure btnSairClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMenuLancamento: TfrmMenuLancamento;

implementation

uses Lancamento, MenuPri;

{$R *.DFM}

{Esta procedure ser executada quando ocorrer o evento Click do boto btnIncluir}
procedure TfrmMenuLancamento.btnIncluirClick(Sender: TObject);
begin
   {Desabilita o formulrio frmMenuLancamento}
   Self.Enabled := False;
   {Cria o formulrio frmLancamento}
   Application.CreateForm(TfrmLancamento, frmLancamento);
   {Coloca o objeto tblLancamento no formato de incluso de dados}
   frmLancamento.tblLancamento.Append;
end;

{Esta procedure ser executada quando ocorrer o evento Close do formulrio}
procedure TfrmMenuLancamento.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
   {Fecha o objeto Query sqlLancamento}
   Self.sqlLancamento.Close;
   {Habilita a opo Lanamento do Menu Plano de Contas}
   frmMenuPri.Lanamento1.Enabled := True;
   Action := CaFree;
end;

{Esta procedure ser executada quando ocorrer o evento Create deste formulrio}
procedure TfrmMenuLancamento.FormCreate(Sender: TObject);
begin
   with sqlLancamento do
      begin
         SQL.Clear;
         SQL.Add('Select a.Lancamento, a.ContaCredito, a.ContaDebito, a.Valor, a.Descricao, '+
         'a.Data, b.Descricao, c.Descricao, a.Status from lancamento as a, planoContas as b, ' +
         'planoContas as c Where (a.ContaCredito = b.PlanoContas) and (a.ContaDebito = c.PlanoContas) '+
         'Order By a.Lancamento');
         Open;
      end;
   {Filtra somente os registros cujo campo Status seja diferente de C, ou seja todos os registro
   no cancelados}
   Self.sqlLancamento.Filter := 'Status <> ''C''';
   {Ativa a filtragem}
   Self.sqlLancamento.Filtered := True;
   {Colocar o nmero do registro clicado no objeto edit txtLancamento}
   txtLancamento.Text := frmMenuLancamento.dbgLancamento.Columns.Items[0].Field.Text
end;

{Esta procedure ser executada quando ocorrer o evento Click do boto btnCancelar}
procedure TfrmMenuLancamento.btnCancelarClick(Sender: TObject);
begin
   {Condio para verificar se o registro a ser cancelado foi cadastrado hoje}
   if StrToDate(frmMenuLancamento.dbgLancamento.Columns.Items[1].Field.Text) = Date then
   begin
   with sqlLancamento do
      begin
         SQL.Clear;
         SQL.Add('Update Lancamento set Status = ''C'' where Lancamento = :1');
         Params[0].AsInteger := StrToInt(txtLancamento.Text);
         ExecSql;
         Close;
      end;
   frmMenuLancamento.FormCreate(frmMenuLancamento);
   end
      else
         {Se o registro a ser cancelado no foi cadastrado hoje, ento mostra uma mensagem
         impossibilitando o cancelamento}
         Application.MessageBox('No  possvel cancelar este lanamento', 'Informao', mb_OK + mb_ICONINFORMATION)
end;

{Esta procedure ser executada quando ocorrer o evento CellClick do grid dbgLancamento}
procedure TfrmMenuLancamento.dbgLancamentoCellClick(Column: TColumn);
begin
   {Colocar o nmero do registro clicado no objeto edit txtLancamento}
   txtLancamento.Text := frmMenuLancamento.dbgLancamento.Columns.Items[0].Field.Text
end;

{Esta procedure ser executada quando ocorrer o evento click do boto btnSair}
procedure TfrmMenuLancamento.btnSairClick(Sender: TObject);
begin
   {Fecha o formulrio frmMenuLancamento}
   Self.Close;
end;

end.
