unit Pagamento;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBCtrls, StdCtrls, Mask, Db, DBTables, ExtCtrls, Buttons;

type
  TfrmPagamento = class(TForm)
    tblFornecedor: TTable;
    dtsFornecedor: TDataSource;
    dblcbFornecedor: TDBLookupComboBox;
    tblFornecedorRegistro: TAutoIncField;
    tblFornecedorFornecedor: TStringField;
    tblFornecedorEndereco: TStringField;
    tblFornecedorCidade: TStringField;
    tblFornecedorEstado: TStringField;
    tblFornecedorCep: TStringField;
    tblFornecedorCgc: TStringField;
    tblFornecedorInscEst: TStringField;
    tblFornecedorTelefone: TStringField;
    tblFornecedorRamal: TStringField;
    tblFornecedorInternet: TStringField;
    tblFornecedorPagto: TStringField;
    tblFornecedorDesconto: TStringField;
    tblFornecedorEntrega: TFloatField;
    tblFornecedorVendedor: TStringField;
    tblFornecedorDataHora: TDateTimeField;
    dbeNumTitulo: TDBEdit;
    tblPagamento: TTable;
    dtsPagamento: TDataSource;
    dbrgTipo: TDBRadioGroup;
    mskEmissao: TMaskEdit;
    mskVencto: TMaskEdit;
    mskPagto: TMaskEdit;
    dbeValor: TDBEdit;
    mskValidDesc: TMaskEdit;
    dbeDesconto: TDBEdit;
    dbeAcrescimo: TDBEdit;
    dbeEmissao: TDBEdit;
    dbeLancamento: TDBEdit;
    dbeVencto: TDBEdit;
    dbePagto: TDBEdit;
    dbeValidDesc: TDBEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    btnOk: TBitBtn;
    btnCancelar: TBitBtn;
    btnSair: TBitBtn;
    tblPagamentoTitulo: TStringField;
    tblPagamentoCGC: TFloatField;
    tblPagamentoValor: TCurrencyField;
    tblPagamentoEmissao: TDateField;
    tblPagamentoVencto: TDateField;
    tblPagamentoLancamento: TDateField;
    tblPagamentoDesconto: TCurrencyField;
    tblPagamentoValidadeDesc: TDateField;
    tblPagamentoPagto: TDateField;
    tblPagamentoAcrescimo: TCurrencyField;
    tblPagamentoTipo: TStringField;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure dblcbFornecedorClick(Sender: TObject);
    procedure mskEmissaoChange(Sender: TObject);
    procedure mskVenctoChange(Sender: TObject);
    procedure mskPagtoChange(Sender: TObject);
    procedure mskValidDescChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
    procedure btnCancelarClick(Sender: TObject);
    procedure btnSairClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmPagamento: TfrmPagamento;

implementation

uses MenuPagto;

{$R *.DFM}

{Esta procedure ser executada quando ocorrer o evento Close do formulrio}
procedure TfrmPagamento.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
   {Fecha a tabela Pagamento}
   Self.tblPagamento.Close;
   {Fecha a tabela Fornecedor}
   Self.tblFornecedor.Close;
   Action := CaFree;
   {Atualiza os dados da tabela de pagamento do formulrio
   menuPagto via o objeto Query sqlPagamento}
   frmMenuPagto.sqlPagamento.Close;
   frmMenuPagto.sqlPagamento.Open;
   {Habilita o formulrio frmMenuPagto}
   frmMenuPagto.Enabled := True;
end;

{Esta procedure ser executada quando ocorrer o evento click do objeto
 DBLookupComboBox1 dblcbFornecedor}
procedure TfrmPagamento.dblcbFornecedorClick(Sender: TObject);
begin
   {Inclui na barra de ttulo o nmero do cgc do fornecedor}
   Self.Caption := 'C.G.C. ' + tblFornecedorCgc.Text;
end;

{Esta procedure ser executada quando ocorrer o evento change do objeto mskEmissao}
procedure TfrmPagamento.mskEmissaoChange(Sender: TObject);
begin
   {Coloca o contedo do objeto mskEmissao no objeto dbeemissao}
   Self.dbeEmissao.Text := Self.mskEmissao.Text;
end;

{Esta procedure ser executada quando ocorrer o evento change do objeto mskVencto}
procedure TfrmPagamento.mskVenctoChange(Sender: TObject);
begin
   {Coloca o contedo do objeto mskVencto no objeto dbeVencto}
   Self.dbeVencto.Text := Self.mskVencto.Text;
end;

{Esta procedure ser executada quando ocorrer o evento change do objeto mskPagto}
procedure TfrmPagamento.mskPagtoChange(Sender: TObject);
begin
   {Coloca o contedo do objeto mskPagto no objeto dbePagto}
   Self.dbePagto.Text := Self.mskPagto.Text;
end;

{Esta procedure ser executada quando ocorrer o evento change do objeto mskValidDesc}
procedure TfrmPagamento.mskValidDescChange(Sender: TObject);
begin
   {Coloca o contedo do objeto mskValidDesc no objeto dbeValidDesc}
   Self.dbeValidDesc.Text := Self.mskValidDesc.Text;
end;

{Esta procedure ser executada quando ocorrer o evento Create do formulrio}
procedure TfrmPagamento.FormCreate(Sender: TObject);
begin
   {Abre a tabela Fornecedor}
   Self.tblFornecedor.Open;
   frmPagamento.dblcbFornecedorClick(frmPagamento);
end;

{Esta procedure ser executada ao evento click do objeto btnOk}
procedure TfrmPagamento.btnOkClick(Sender: TObject);
begin
   {Condio para a confirmao da incluso do registro}
   if Application.MessageBox('Confirma a Incluso ou '+
     'Alterao deste Pagamento?', 'Confirmao',
   mb_YesNo + mb_IconInformation) = IdYes then
      {Verdadeira}
      begin
         {Inclui a data atual no objeto dbeLancamento}
         Self.dbeLancamento.Text := dateTostr(Date);
         {Grava as informaes na tabela de despesa}
         Self.tblPagamento.Post;
         {Apaga o contedo dos objetos msk}
         Self.mskEmissao.Text := '';
         Self.mskVencto.Text := '';
         Self.mskPagto.Text := '';
         Self.mskValidDesc.Text := '';
      end
   {Falsa}
   else
      {Cancela a incluso da despesa}
      Self.tblPagamento.Cancel;
   {Fecha o formulario}
   Self.Close;
end;

{Esta procedure ser executada ao evento click do boto btnCancelar}
procedure TfrmPagamento.btnCancelarClick(Sender: TObject);
begin
   {Cancela a entrada ou a edio do registro}
   Self.tblPagamento.Cancel;
   {Fecha o formulrio}
   Self.Close;
end;

{Esta procedure ser executada ao evento click do boto btnSair}
procedure TfrmPagamento.btnSairClick(Sender: TObject);
begin
   {Fecha o formulrio}
   Self.Close;
end;

end.
