unit PlanoContas;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBCtrls, StdCtrls, Mask, DBTables, Buttons;

type
  TfrmPlanoContas = class(TForm)
    tblPlano1: TTable;
    dtsPlano1: TDataSource;
    DBText1: TDBText;
    dbllConta: TDBLookupListBox;
    btnOk: TBitBtn;
    tblPlano2: TTable;
    dtsPlano2: TDataSource;
    editNova: TDBEdit;
    editDescricao: TDBEdit;
    editComplemento: TEdit;
    lblSelecione: TLabel;
    lblConsolidado: TLabel;
    lblSuperior: TLabel;
    lblComplemento: TLabel;
    lblNova: TLabel;
    lblDescricao: TLabel;
    btnSair: TBitBtn;
    cbCons: TCheckBox;
    cbContinua: TCheckBox;
    EditSuperior: TDBEdit;
    tblPlano2PlanoContas: TAutoIncField;
    tblPlano2Conta: TStringField;
    tblPlano2Superior: TStringField;
    tblPlano2Descricao: TStringField;
    tblPlano2Consolidacao: TBooleanField;
    tblPlano1PlanoContas: TAutoIncField;
    tblPlano1Conta: TStringField;
    tblPlano1Superior: TStringField;
    tblPlano1Descricao: TStringField;
    tblPlano1Consolidacao: TBooleanField;
    procedure FormCreate(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
    procedure dbllContaClick(Sender: TObject);
    procedure editComplementoChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnSairClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmPlanoContas: TfrmPlanoContas;

implementation

uses MenuPri;

{$R *.DFM}

{Esta procedure ser executada quando ocorrer o evento Create no formulrio frmPlanoContas}
procedure TfrmPlanoContas.FormCreate(Sender: TObject);
begin
   {Ativa os objetos table tblPlano1 e tblPlano2}
   tblPlano1.Open;
   tblPlano2.Open;
   {Condio para verificar se se trata de incluso ou Alterao}
   if frmMenuPri.mmMenuPri.Tag = 1 {Incluso} then
      {Condio verdadeira, ento deixa a tabela em condio de Incluso}
      tblPlano2.append
   else
      begin
         {Caso contrrio, ou seja se tratando de alterao, ento altera a propriedade
         caption do formulrio para a string abaixo}
         Self.Caption := 'Manuteno no Plano de Contas';
         {Inclui no objeto editSuperior o nmero da conta}
         editSuperior.Text := tblPlano1Conta.Text;
         {Altera a propriedade caption do objeto lblSuperior para "conta"}
         lblSuperior.Caption := 'Conta';
         {As trs prximas linhas deixam os respectivos objetos invisveis}
         editNova.Visible := False;
         editComplemento.Visible := False;
         cbContinua.Visible := False;
         {O objeto cbCons fica desabilitado}
         cbCons.Enabled := False;
         {Altera a propriedade DataSource do objeto editDescricao para dtsPlano1}
         editDescricao.DataSource := dtsPlano1;
      end;
end;

{Esta procedure ser executada quando ocorrer o evento Click no boto btnOk}
procedure TfrmPlanoContas.btnOkClick(Sender: TObject);
begin
   {Condio para verificar se  incluso ou edio}
   if frmMenuPri.mmMenuPri.Tag = 1 {Incluso} then
      {Condio verdadeira}
      begin
         {Ser mostrada uma mensagem pedindo a confirmao da incluso}
         If Application.MessageBox('Confirma a Incluso desta Conta?', 'Confirmao',
         mb_YesNo + mb_IconQuestion) = idYes then
            begin
               {Caso seja confirmada a incluso, ento ser verificado se o objeto
               CheckBox cbCons est marcado}
               if cbCons.Checked = True then
                  {Caso esteja marcado, ento no campo consolidao da tabela ser
                  acrescida da palavra True}
                  tblPlano2Consolidacao.Text := 'True'
               else
                  {Caso contrrio ser acrescida a palavra False}
                  tblPlano2Consolidacao.Text := 'False';
            try
               {Aqui ser feito a gravao de uma nova Conta}
               Self.tblPlano2.Post;
               except
                  on EDBEngineError do
                  {Caso exista um nmero de conta gravado anteriormente que seja
                  igual a nova, ento no ser feita esta gravao, causa do erro
                  "Chave Primria" na tabela}
                  Application.MessageBox('Existe uma conta cadastrada com este nmero' +
                  Chr(13) + 'No  possvel incluir esta conta.', 'Error', mb_Ok +
                  mb_IconError);
               end;
            end;
         {Desativa e ativa a tabela para a atualizao dos dados}
         tblPlano1.Close;
         tblPlano1.Open;
            {Verifica se objeto CheckBox cbContinua est marcado, para uma nova incluso}
            If cbContinua.Checked  = True then
               begin
                  {Se a condio for verdadeira, ento coloca a tabela na
                  condio de incluso}
                  tblPlano2.Append;
                  editSuperior.Text := tblPlano1Conta.Text;
                  editComplemento.SetFocus;
                  {As duas prximas linhas apagam o contedo dos respectivos objetos}
                  editComplemento.Text := '';
                  editNova.Text := '';
               end
            else
               {Caso contrrio, ou seja, a incluso no  contnua, ento fecha o formulrio}
               Self.Close;
      end
         {Condio falsa, ou seja, se trata de uma alterao de dados da conta}
         else
            begin
               {Ser mostrada uma mensagem pedindo a confirmao da Alterao}
               If Application.MessageBox('Confirma a mudana da Descrio desta Conta?',
               'Confirmao', mb_YesNo + mb_IconQuestion) = idYes then
                  begin
                     {Caso confirmado, ento, ser gravada a alterao}
                     Self.tblPlano1.Post;
                     {Em seguida o formulrio ser fechado}
                     Self.Close;
                  end;
            end;
end;

{Esta procedure ser executada quando ocorrer o evento Click no objeto dbllConta}
procedure TfrmPlanoContas.dbllContaClick(Sender: TObject);
begin
   {Condio para verificar se  incluso ou alterao}
   if frmMenuPri.mmMenuPri.Tag = 1 {Incluso} then
      begin
         {Condio verdadeira, ou seja, incluso, ento os objetos editcomplemento
         e editNova sero ativados}
         editComplemento.Enabled := True;
         editNova.Enabled := True;
         editComplemento.SetFocus;
      end;
         {O objeto editDescricao ser ativado}
         editDescricao.Enabled := True;
         {Incluir no objeto editSuperior o nmero da conta selecionado}
         editSuperior.Text := tblPlano1Conta.Text;
         {Condio para verificar o contedo do campo Consolidao da Tabela}
         if tblPlano1Consolidacao.Text = 'True' then
            {Caso o contedo do campo seja "True", ento incluir a string "Consolidado"
            no objeto lblConsolidado}
            lblConsolidado.Caption := 'Consolidado'
         else
            {Caso contrrio, incluir a string "No Consolidado"}
            lblConsolidado.Caption := 'No Consolidado'
end;

{Procedure que ser executada quando ocorrer o evento Change no objeto editComplemento}
procedure TfrmPlanoContas.editComplementoChange(Sender: TObject);
begin
   {Incluir no objeto EditNova o contedo do objeto editSuperior acrescido de um ponto (.)
   mais o contedo do objeto editComplemento}
   editNova.text := EditSuperior.text + editComplemento.text;
end;

{Procedure que ser executada quando ocorrer o evento Close no formulrio}
procedure TfrmPlanoContas.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
   {Fecha os objetos table tblPlano1 e tblPlano2}
   tblPlano1.Close;
   tblPlano2.Close;
   {Habilita a opo Manuteno do menu Plano de contas}
   frmMenuPri.Manuteno1.Enabled := True;
   {O formulrio  fechado e a memria alocada  liberada}
   Action := CaFree;
end;

{Procedure que ser executada quando ocorrer o evento Click no boto btnSair}
procedure TfrmPlanoContas.btnSairClick(Sender: TObject);
begin
   {Fecha o formulrio}
   Self.close;
end;

end.
