unit Recebimento;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, StdCtrls, Buttons, Mask, ExtCtrls, DBCtrls;

type
  TfrmRecebimento = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    dblcbCliente: TDBLookupComboBox;
    dbeNumTitulo: TDBEdit;
    dbrgTipo: TDBRadioGroup;
    mskEmissao: TMaskEdit;
    mskVencto: TMaskEdit;
    mskPagto: TMaskEdit;
    dbeValor: TDBEdit;
    mskValidDesc: TMaskEdit;
    dbeDesconto: TDBEdit;
    dbeAcrescimo: TDBEdit;
    dbeEmissao: TDBEdit;
    dbeLancamento: TDBEdit;
    dbeVencto: TDBEdit;
    dbePagto: TDBEdit;
    dbeValidDesc: TDBEdit;
    btnOk: TBitBtn;
    btnCancelar: TBitBtn;
    btnSair: TBitBtn;
    tblCliente: TTable;
    dtsCliente: TDataSource;
    tblRecebimento: TTable;
    dtsRecebimento: TDataSource;
    tblClienteRegistro: TAutoIncField;
    tblClienteCliente: TStringField;
    tblClienteEndereco: TStringField;
    tblClienteCidade: TStringField;
    tblClienteEstado: TStringField;
    tblClienteCep: TStringField;
    tblClienteCgc: TStringField;
    tblClienteTelefone: TStringField;
    tblClienteRamal: TStringField;
    tblClienteContato: TStringField;
    tblClienteInscEst: TStringField;
    tblClienteInternet: TStringField;
    tblClienteDataHora: TDateTimeField;
    tblRecebimentoTitulo: TStringField;
    tblRecebimentoCGC: TFloatField;
    tblRecebimentoValor: TCurrencyField;
    tblRecebimentoEmissao: TDateField;
    tblRecebimentoVencto: TDateField;
    tblRecebimentoLancamento: TDateField;
    tblRecebimentoDesconto: TCurrencyField;
    tblRecebimentoValidadeDesc: TDateField;
    tblRecebimentoPagto: TDateField;
    tblRecebimentoAcrescimo: TCurrencyField;
    tblRecebimentoTipo: TStringField;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure dblcbClienteClick(Sender: TObject);
    procedure mskEmissaoChange(Sender: TObject);
    procedure mskVenctoChange(Sender: TObject);
    procedure mskPagtoChange(Sender: TObject);
    procedure mskValidDescChange(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
    procedure btnCancelarClick(Sender: TObject);
    procedure btnSairClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmRecebimento: TfrmRecebimento;

implementation

uses MenuRecebto;

{$R *.DFM}

{Esta procedure ser executada quando ocorrer o evento Create do formulrio}
procedure TfrmRecebimento.FormCreate(Sender: TObject);
begin
   {Abre a tabela Fornecedor}
   Self.tblCliente.Open;
end;

{Esta procedure ser executada quando ocorrer o evento Close do formulrio frmRecebimento}
procedure TfrmRecebimento.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
   {Fecha a tabela Pagamento}
   Self.tblRecebimento.Close;
   {Fecha a tabela Fornecedor}
   Self.tblCliente.Close;
   Action := CaFree;
   {Atualiza os dados da tabela de pagamento do formulrio
   MenuRecebto via o objeto Query sqlPagamento}
   frmMenuRecebto.sqlRecebimento.Close;
   frmMenuRecebto.sqlRecebimento.Open;
   {Habilita o formulrio frmMenuRecebto}
   frmMenuRecebto.Enabled := True;
end;

{Esta procedure ser executada quando ocorrer o evento click do objeto
DBLookupComboBox1 dblcbFornecedor}
procedure TfrmRecebimento.dblcbClienteClick(Sender: TObject);
begin
   {Inclui na barra de ttulo o nmero do cgc do fornecedor}
   Self.Caption := 'C.G.C. ' + tblClienteCgc.Text;
end;

{Esta procedure ser executada quando ocorrer o evento change do objeto mskEmissao}
procedure TfrmRecebimento.mskEmissaoChange(Sender: TObject);
begin
   {Coloca o contedo do objeto mskEmissao no objeto dbeemissao}
   Self.dbeEmissao.Text := Self.mskEmissao.Text;
end;

{Esta procedure ser executada quando ocorrer o evento change do objeto mskVencto}
procedure TfrmRecebimento.mskVenctoChange(Sender: TObject);
begin
   {Coloca o contedo do objeto mskVencto no objeto dbeVencto}
   Self.dbeVencto.Text := Self.mskVencto.Text;
end;

{Esta procedure ser executada quando ocorrer o evento change do objeto mskPagto}
procedure TfrmRecebimento.mskPagtoChange(Sender: TObject);
begin
   {Coloca o contedo do objeto mskPagto no objeto dbePagto}
   Self.dbePagto.Text := Self.mskPagto.Text;
end;

{Esta procedure ser ativada no evento change do objeto
mskValidDesc}
procedure TfrmRecebimento.mskValidDescChange(Sender: TObject);
begin
   {Coloca o contedo do objeto mskValidDesc no objeto dbeValidDesc}
   Self.dbeValidDesc.Text := Self.mskValidDesc.Text;
end;

{Esta procedure ser executada quando ocorrer o evento click do objeto btnOk}
procedure TfrmRecebimento.btnOkClick(Sender: TObject);
begin
   {Condio para a confirmao da incluso do registro}
   if Application.MessageBox('Confirma a Incluso ou '+
     'Alterao deste Pagamento?', 'Confirmao',
   mb_YesNo + mb_IconInformation) = IdYes then
      {Verdadeira}
      begin
         {Inclui a data atual no objeto dbeLancamento}
         Self.dbeLancamento.Text := dateTostr(Date);
         {Grava as informaes na tabela de despesa}
         Self.tblRecebimento.Post;
         {Apaga o contedo dos objetos msk}
         Self.mskEmissao.Text := '';
         Self.mskVencto.Text := '';
         Self.mskPagto.Text := '';
         Self.mskValidDesc.Text := '';
      end
   {Falsa}
   else
      {Cancela a incluso da despesa}
      Self.tblRecebimento.Cancel;
   {Fecha o formulario}
   Self.Close;
end;

{Esta procedure ser executada quando ocorrer o evento click do boto btnCancelar}
procedure TfrmRecebimento.btnCancelarClick(Sender: TObject);
begin
   {Cancela a entrada ou a edio do registro}
   Self.tblRecebimento.Cancel;
   {Fecha o formulrio}
   Self.Close;
end;

{Esta procedure ser executada quando ocorrer o evento click do boto btnSair}
procedure TfrmRecebimento.btnSairClick(Sender: TObject);
begin
   {Fecha o formulrio}
   Self.Close;
end;

end.
