unit RemessaCartorio;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, Db, DBTables, Grids, DBGrids, StdCtrls, DBCtrls, Mask, Buttons,
  ExtCtrls;

type
  TfrmRemessaCartorio = class(TForm)
    dbgCartorio: TDBGrid;
    sqlCartorio: TQuery;
    dtsCartorio: TDataSource;
    mmRemessa: TMainMenu;
    Remessa1: TMenuItem;
    mmEnviar: TMenuItem;
    mmAlterar: TMenuItem;
    N1: TMenuItem;
    mmFim: TMenuItem;
    tblNomeCartorio: TTable;
    tblRemessaCartorio: TTable;
    dtsRemessaCartorio: TDataSource;
    dtsNomeCartorio: TDataSource;
    dbeRemessa: TDBEdit;
    dbeProtesto: TDBEdit;
    dbeBaixa: TDBEdit;
    Panel1: TPanel;
    dblcbNomeCartorio: TDBLookupComboBox;
    mskRemessa: TMaskEdit;
    mskProtesto: TMaskEdit;
    mskBaixa: TMaskEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    dbeTitulo: TDBEdit;
    Label5: TLabel;
    btnOk: TBitBtn;
    btnCancelar: TBitBtn;
    btnSair: TBitBtn;
    sqlCartorioTitulo: TStringField;
    sqlCartorioRemessa: TDateField;
    sqlCartorioProtesto: TDateField;
    sqlCartorioBaixa: TDateField;
    sqlCartorioRegistro_1: TIntegerField;
    sqlCartorioNome: TStringField;
    tblRemessaCartorioIdRemessa: TAutoIncField;
    tblRemessaCartorioRegistro: TIntegerField;
    tblRemessaCartorioTitulo: TStringField;
    tblRemessaCartorioRemessa: TDateField;
    tblRemessaCartorioProtesto: TDateField;
    tblRemessaCartorioBaixa: TDateField;
    tblNomeCartorioRegistro: TAutoIncField;
    tblNomeCartorioNome: TStringField;
    tblNomeCartorioContato: TStringField;
    tblNomeCartorioTelefone: TStringField;
    sqlCartorioIdRemessa: TIntegerField;
    sqlCartorioRegistro: TIntegerField;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure mmEnviarClick(Sender: TObject);
    procedure mskRemessaChange(Sender: TObject);
    procedure mskProtestoChange(Sender: TObject);
    procedure mskBaixaChange(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
    procedure btnCancelarClick(Sender: TObject);
    procedure btnSairClick(Sender: TObject);
    procedure mmAlterarClick(Sender: TObject);
    procedure mmFimClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmRemessaCartorio: TfrmRemessaCartorio;

implementation

{$R *.DFM}

{Esta procedure ser executada quando ocorrer o evento Create do formulrio}
procedure TfrmRemessaCartorio.FormCreate(Sender: TObject);
begin
   {Abre objeto Query sqlCartorio}
   Self.sqlCartorio.Open;
end;

{Esta procedure ser executada quando ocorrer o evento Close do formulrio}
procedure TfrmRemessaCartorio.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
   {Fecha o objeto query sqlCartorio}
   Self.sqlCartorio.Close;
   {Fecha a tabela Cartorio}
   Self.tblNomeCartorio.Close;
   {Fecha a tabela Remessa Cartorio}
   Self.tblRemessaCartorio.Close;
   Action := CaFree;
end;

{Esta procedure ser executadam quando ocorrer o evento click da opo enviar
do menu Remessa}
procedure TfrmRemessaCartorio.mmEnviarClick(Sender: TObject);
begin
   With frmRemessaCartorio do
      begin
         {Tamanho da largura}
         Height := 332;
         {Torna o objeto panel1 visvel}
         Panel1.Visible := True;
         {Abre a tabela RemessaCartorio}
         tblRemessaCartorio.Open;
         {Abre a tabela Cartorio}
         tblNomeCartorio.Open;
         {Coloca a tabela RemessaCartorio em posio de incluso}
         tblRemessaCartorio.Append;
         {Desabilita a opo enviar do menu Remessa}
         mmEnviar.Enabled := False;
         {Desabilita a opo alterar do menu Remessa}
         mmAlterar.Enabled := False;
      end;
end;

{Esta procedure ser executada quando ocorrer o evento Change do objeto mskRemessa}
procedure TfrmRemessaCartorio.mskRemessaChange(Sender: TObject);
begin
   {Copia o contedo do objeto mskRemessa para dbeRemessa}
   Self.dbeRemessa.Text := Self.mskRemessa.Text;
end;

{Esta procedure ser executada quando ocorrer o evento Change do objeto mskProtesto}
procedure TfrmRemessaCartorio.mskProtestoChange(Sender: TObject);
begin
   {Copia o contedo do objeto mskProtesto para dbeProtesto}
   Self.dbeProtesto.Text := Self.mskProtesto.Text;
end;

{Esta procedure ser executada quando ocorrer o evento Change do objeto mskBaixa}
procedure TfrmRemessaCartorio.mskBaixaChange(Sender: TObject);
begin
   {Copia o contedo do objeto mskBaixa para dbeBaixa}
   Self.dbeBaixa.Text := Self.mskBaixa.Text;
end;

{Esta procedure ser executada quando ocorrer o evento Click do boto btnOk}
procedure TfrmRemessaCartorio.btnOkClick(Sender: TObject);
begin
   {Condio para a confirmao da incluso do registro}
   if Application.MessageBox('Confirma a Incluso ou '+
     'Alterao do Envio deste Ttulo para Cartrio?',
     'Confirmao', mb_YesNo + mb_IconInformation) = IdYes then
     {Se a condio for verdadeira ento ser gravado o registro}
     tblRemessaCartorio.Post;
   {Fecha o objeto query sqlCartorio}
   Self.sqlCartorio.Close;
   {Abre o objeto Query sqlCartorio (para atualizar)}
   Self.sqlCartorio.Open;
   {Torna o objeto Panel1 invisvel}
   Panel1.Visible := False;
   {Tamanho da largura do formulrio}
   Self.Height := 182;
end;

{Esta procedure ser executada quando ocorrer o evento Click do boto btnCancelar}
procedure TfrmRemessaCartorio.btnCancelarClick(Sender: TObject);
begin
   {Cancela a incluso ou a edio do registro}
   Self.tblRemessaCartorio.Cancel;
   {Torna o objeto Panel1 invisvel}
   Panel1.Visible := False;
   {Tamanho da largura do formulrio}
   Self.Height := 182;
   {Habilita a opo enviar do menu Remessa}
   mmEnviar.Enabled := True;
   {Habilita a opo alterar do menu Remessa}
   mmAlterar.Enabled := True;
end;

{Esta procedure ser executada quando ocorrer o evento Click do boto btnSair}
procedure TfrmRemessaCartorio.btnSairClick(Sender: TObject);
begin
   {Fecha o formulrio}
   Self.Close;
end;

{Esta procedure ser executada quando ocorrer o evento Click da opo alterar
do menu Remessa}
procedure TfrmRemessaCartorio.mmAlterarClick(Sender: TObject);
begin
   With frmRemessaCartorio do
      begin
         {Abre a tabela RemessaCartorio}
         tblRemessaCartorio.Open;
         {Abre a tabela Cartorio}
         tblNomeCartorio.Open;
         {Filtra o registro selecionado para a edio}
         tblRemessaCartorio.Filter := 'Titulo = '+(frmRemessaCartorio.
            dbgCartorio.Columns.Items[1].Field.Text);
         {Ativa o filtro}
         tblRemessaCartorio.Filtered := True;
         {Altera a largura do formulrio}
         Height := 332;
         {Torna o objeto Panel1 visvel}
         Panel1.Visible := True;
         {Coloca o registro selecionado em modo de edio}
         tblRemessaCartorio.Edit;
         {Cola o contedo do objeto dbeRemessa para mskRemessa}
         mskRemessa.Text := dbeRemessa.text;
         {Cola o contedo do objeto dbeProtesto para mskProtesto}
         mskProtesto.Text := dbeProtesto.Text;
         {Cola o contedo do objeto dbeBaixa para mskBaixa}
         mskBaixa.Text := dbeBaixa.Text;
      end;
end;

{Esta procedure ser executada quando ocorrer o evento Click da opo Fim do
menu Remessa}
procedure TfrmRemessaCartorio.mmFimClick(Sender: TObject);
begin
	{Executa a procedure Click do boto btnCancelar}
	frmRemessaCartorio.btnCancelarClick(frmRemessaCartorio);
   {Fecha o formulrio}
   Self.Close;
end;

end.
